<?php

/*******************************************
* SPMod
* Version 1.0
* © mamavrn.ru
********************************************
* parsers.php
*******************************************/

if (!defined('SMF')) 
    die('Hacking attempt...');

//Список доступных парсеров
$parsers = array(
	'sima-land.ru' => 'SimaLand',
	'stok-m.ru' => 'StokMarket',
	'natali37.ru' => 'Natali37',
	'votonia.ru' => 'Votonia',
	'sp-savage.ru' => 'spsavage',
	'volgoshoes.ru' => 'Volgoshoes',
	'odezhda-master.ru' => 'OdezhdaMaster',
	'xn--80abzqel.xn--p1ai' => 'Bairon',
	'ikea.com' => 'Ikea',
);	

function CreateDomObject($link)
{
	global $txt;
	include_once('SPMod/simple_html_dom.php');	 
	if(isset($link) && !empty($link)) 
		if (stripos($link, PHP_EOL))
			$html = str_get_html($link);
		else
			$html = file_get_html($link);	
	else
		fatal_error($txt['spmod_nopageurl']);	
	return $html;
}	

function GrabPic($imgurl)
{
	global $boardurl, $user_info;
	
	$ifn = '/images/' . uniqid(strval($user_info['id'])) . '.jpg';
	if (isset($imgurl) && !empty($imgurl) && file_put_contents(__DIR__ . $ifn, file_get_contents($imgurl)))
		return $boardurl . '/SPMod' . $ifn;
	else
		return $boardurl . '/SPMod/images/sp/korob.png';
}

function SimaLand($link)
{
	$html = CreateDomObject($link);	
	if ($html)
	{
		foreach($html->find('div.card') as $tab)
		{         
			$ti = $tab->find('div.card-table-desc', 0)->find('a', 0);
			$va = $tab->find('div.col-1', 0)->find('div', 1)->find('span.value', 0);
			preg_match_all("/((http:\/\/cdn)?[a-z0-9\-\.\/]+(!?\.jpg))/", $tab->find('div.th140', 0)->find('a', 0)->outertext, $str1);
			$pr = $tab->find('[data-price-value]', 0);
			if ($str1[0][0] != '' && isset($ti) && isset($va))
			{
				$parseresult[] = array(
					'name' => htmlspecialchars_decode($ti->plaintext),
					'description' => htmlspecialchars_decode($ti->plaintext),
					'image' => $str1[0][0],
					'price' => floatval(preg_replace("/[^-0-9\.]/", "", $pr->plaintext)),
					'link' => 'https://www.sima-land.ru/' . $ti->href,
					'articul' => $va->plaintext,
					'linecount' => 0,
					'params' => '',
					'linecaption' => '',
				);
			}
		}
		$html->clear(); 
		unset($html); 
		return $parseresult;
	} else return false;
}

function StokMarket($link)
{	
	$html = CreateDomObject($link);
   	if ($html)
	{
		if($html->innertext!='' and count($html->find('div[id^=product_]')))
		{
			foreach($html->find('div[id^=product_]') as $pro)
			{
				$n = $pro->find('.name', 0);
				$d = $pro->find('.description', 0);
				$pr = $pro->find('.price', 0);
				$a = $n -> find('a', 0);
				$va = $pro->find('[name=product_id]', 0);

				$parseresult[] = array(
					'name' => $a->plaintext,
					'description' => $d->plaintext,
					'image' => $pro->find('img', 0)->src,
					'price' => floatval(preg_replace("/[^-0-9\.]/", "", $pr->plaintext)),
					'link' => $a->href,
					'articul' => $va->value,
					'linecount' => 0,
					'params' => '',
					'linecaption' => '',
				);			
			}
		}
		$html->clear(); 
		unset($html);
		return $parseresult;
	} else return false;
}

function Natali37($link)
{	
	$html = CreateDomObject($link);
   	if ($html)
	{	
		if($html->innertext!='' and count($html->find('div.prod')))
		{
			foreach($html->find('div.prod') as $pro)
			{
				$a = $pro->find('a', 0);
				$i = $pro->find('img', 0);
				if (count($pro->find('div[class^=price]')))
				{
					$pr = $pro->find('div[class^=price]', 0);
					$p = $pr->plaintext;
				}
				else $p = 0;
				
				$parseresult[] = array(
					'name' => $a->title,
					'description' => $a->title,
					'image' => GrabPic($i->src),
					'price' => floatval(preg_replace("/[^-0-9\.]/", "", $p)),
					'link' => 'http://www.natali37.ru/' . $a->href,
					'articul' => 0,
					'linecount' => 0,
					'params' => '',
					'linecaption' => '',
				);						
			}
		}
		$html->clear(); 
		unset($html); 
		return $parseresult;
	} else return false;	
}

function Votonia($link)
{	
	$html = CreateDomObject($link);
   	if ($html)
	{		
		if($html->innertext!='' and count($html->find('div[id^=prod-]')))
		{
			foreach($html->find('div[id^=prod-]') as $pro)
			{
				$photo = $pro->find('img', 0);
				$a = $pro->find('a', 1);
				$pr = $pro->find('div.cat_product_price', 0);
				$articul = $pro->find('div[data-id]', 0);
				$descr = $pro->find('div[data-shop]', 0);
				$parseresult[] = array(
					'name' =>  $a->plaintext,
					'description' =>  $descr->attr['data-shop'],
					'image' => $photo->src,
					'price' => floatval(preg_replace("/[^-0-9\.]/", "", $pr->plaintext)),
					'link' => 'http://www.votonia.ru' . $a->href,
					'articul' => $articul->attr['data-id'],
					'linecount' => 0,
					'params' => '',
					'linecaption' => '',
				);
			}
		}
		$html->clear(); 
		unset($html);
		return $parseresult;
	} else return false;	
}

function spsavage($link)
{	
	$html = CreateDomObject($link);
   	if ($html)
	{		
		if($html->innertext!='' and count($html->find('div.itembody')))
		{
			foreach($html->find('div.itembody') as $pro)
			{
				$par = $pro->find('div.itemparams', 0);
				$name = $par->find('div.itemtitle', 0);
				$a = $pro->find('a', 0);
				preg_match_all("/([a-z0-9\_\-\.\/]+(!?\.jpg))/", $a->outertext, $str1);	
				$price = $par->find('.sum', 1);
				if ($str1[0][0] != '')
				{
					$parseresult[] = array(
						'name' =>  $name->plaintext,
						'description' =>  $name->plaintext,
						'image' => GrabPic('http://sp-savage.ru/' . $str1[0][0]),
						'price' => floatval($price->innertext),
						'link' => 'http://sp-savage.ru/' . $a->href,
						'articul' => 0,
						'linecount' => 0,
						'params' => '',
						'linecaption' => '',
					);				
				}	
			}
		}
		$html->clear(); 
		unset($html);
		return $parseresult;
	} else return false;		
}

function Volgoshoes($link)
{	
	$html = CreateDomObject($link);
   	if ($html)
	{		
		if($html->innertext!='' and count($html->find('div.catalog-item-info')))
		{
			foreach($html->find('div.catalog-item-info') as $pro)
			{
				if (count($pro->find('div.catalog-item-desc')))
				{
					$par = $pro->find('div.catalog-item-desc', 0);
					$name = $par->find('div.catalog-item-title', 0);
					$a = $par->find('a', 0);
					if (count($par->find('div.catalog-item-image')))
					{
						$imgblock = $par->find('div.catalog-item-image', 0);
						$imga = $imgblock->find('a', 0);
						preg_match_all("/([a-z0-9\_\-\.\/]+(!?\.jpeg))/", $imga->outertext, $str1);	
						
						$price = $par->find('.catalog-item-price', 2)->innertext;
						$price = preg_replace("/[^0-9\.]/", '', $price);

						if ($str1[0][0] != '')
						{
							$parseresult[] = array(
								'name' =>  $a->plaintext,
								'description' => $a->plaintext,
								'image' => GrabPic('http://www.volgoshoes.ru/' . $str1[0][0]),
								'price' => floatval($price),
								'link' => 'http://www.volgoshoes.ru' . $a->href,
								'articul' => 0,
								'linecount' => 0,
								'params' => '',
								'linecaption' => '',
							);						
						}	
					}
				}
			}
		}
		$html->clear(); 
		unset($html);
		return $parseresult;
	} else return false;		
}

function OdezhdaMaster($link)
{	
	$html = CreateDomObject($link);
	if ($html)
	{		
		if($html->innertext!='' and count($html->find('div.ProdBord')))
		{
			foreach($html->find('div.ProdBord') as $pro)
			{
				$a = $pro->find('a', 0);
				$name = str_replace('<b>', '', $a->plaintext);
				$name = str_replace('</b>', '', $name);
				$photo = $pro->find('img', 0);
				$prob = $pro->find('.PriceAttr', 0);
				$price = $prob->innertext;
				$price = preg_replace("/[^0-9]/", '', $price);
				
				$parseresult[] = array(
					'name' => $name,
					'description' => $name,
					'image' => 'http://odezhda-master.ru/' . $photo->src,
					'price' => floatval($price),
					'link' => $a->href,
					'articul' => 0,
					'linecount' => 0,
					'params' => '',
					'linecaption' => '',
				);				
			}
		}
		$html->clear(); 
		unset($html);
		return $parseresult;	
	} else return false;		
}

function Bairon($link)
{	
	$html = CreateDomObject($link);
	if ($html)
	{		
		if($html->innertext!='' and count($html->find('div.product_item')))
		{
			foreach($html->find('div.product_item') as $pro)
			{
				$photo = $pro->find('img', 0);
				$a =  $pro->find('a', 2);	
				$price = $pro->find('div.pricing', 0);
				$price = preg_replace("/[^0-9]/", '', $price);
							
				$parseresult[] = array(
					'name' => $a->plaintext,
					'description' => $a->plaintext,
					'image' => GrabPic('http://xn--80abzqel.xn--p1ai' . $photo->src),
					'price' => floatval($price),
					'link' => 'http://xn--80abzqel.xn--p1ai' . $a->href,
					'articul' => 0,
					'linecount' => 0,
					'params' => '',
					'linecaption' => '',
				);				
			}
		}
		$html->clear(); 
		unset($html);
		return $parseresult;
	} else return false;				
}

function Ikea($link)
{	
	$html = CreateDomObject($link);
	if ($html)
	{		
		if($html->innertext!='' and count($html->find('div[class^=threeColumn]')))
		{
			foreach($html->find('div[class^=threeColumn]') as $pro)
			{
				if (count($pro->find('div.image')))
				{
					$ph = $pro->find('div.image', 0);		
					$a =  $ph->find('a', 0);	
					$photo = $ph->find('img', 0);
					if (count($pro->find('div.productDetails')))
					{
						$Detailsdiv = $pro->find('div.productDetails', 0);
						$price = $Detailsdiv->find('div[class^=price]', 0);
						$pr = preg_replace("/[^0-9]/", '', $price->plaintext);

						$name = $Detailsdiv->find('div[class^=productTitle]', 0);
						$descr = $Detailsdiv->find('div.productDesp', 0);
		
						$parseresult[] = array(
							'name' => $name->plaintext,
							'description' => $descr->plaintext,
							'image' => 'http://ikea.com' . $photo->src,
							'price' => floatval($pr),
							'link' =>  'http://ikea.com' . $a->href,
							'articul' => 0,
							'linecount' => 0,
							'params' => '',
							'linecaption' => '',
						);						
					}
				}
			}
		}
		$html->clear(); 
		unset($html);
		return $parseresult;
	} else return false;						
}
	
?>