<?php

/*******************************************
* SPMod
* Version 1.0
* © mamavrn.ru
********************************************
* SPMod.php
*******************************************/

if (!defined('SMF'))
	die('Hack Attempt...');

function SPModMain()
{
	global $context, $scripturl, $txt;
	require_once('Subs-SPMod.php');

	loadTemplate('SPMod');
	loadLanguage('SPMod');
	
	$context['linktree'][] = array(
  		'url' => $scripturl. '?action=spmod',
 		'name' => $txt['spmod'],
	);	

	$subActions = array(
		'orginfo' => 'SPmodOrgInfo',
	    'spcat' => 'SPmodCategories',
		'editcat' => 'SPmodEditCat',
		'goods' => 'SPModGoods',
		'proc' => 'SPModProcurements',
		'buy' => 'SPModBuy',
		'unbuy' => 'SPModUnBuy',
		'oneunbuy' => 'SPModOneUnBuy',
		'no' => 'SPModNo',
		'yes' => 'SPModYes',
		'delbuy' => 'SPModOrdDel',
		'parse' => 'Parse',
		'editgood' => 'SPModEditGood',
		'editproc' => 'SPModEditProc',
		'stopproc' => 'SPModStopProc',
		'closeproc' => 'SPModCloseProc',
		'closeproc2' => 'SPModCloseProcByAdmin',
		'delproc' => 'SPModDelProc',
		'payproc' => 'SPModPayProc',
		'reportproc' => 'SPModReportProc',		
		'buys' => 'SPModBuys',
		'sizes' => 'SPModSizes',
		'editsizes' => 'SPModEditSizes',
		'parser' => 'SPModParser',
		'toxml' => 'SaveToXML',
		'fromxml' => 'LoadFromXML',
		'fromcsv' => 'LoadFromCSV',
		'addandbuy' => 'SPModAddAndBuy',
		'myproc' => 'SPModMyProc',		
		'spadmin' => 'SPModAdmin',		
		'changeop' => 'SPModChangeOrgPerc',
		'changetr' => 'SPModChangeTR',
		'pay' => 'SPModPayment',
		'help' => 'SPHelp',
	);

	$context['tab_links'] = array();

	$context['tab_links'][] = array('action' => 'orginfo',
									'label' =>  $txt['spmod_info'],
									'visible' => allowedTo(array('view_spbuy', 'view_spmod', 'view_spadmin')));
	
	$context['tab_links'][] = array('action' => 'spcat',
									'label' =>  $txt['spmod_cats'],
									'visible' => allowedTo(array('view_spmod', 'view_spadmin')));

	$context['tab_links'][] = array('action' => 'goods',
									'label' =>  $txt['spmod_goods'],
									'visible' => allowedTo(array('view_spmod', 'view_spadmin')));

	$context['tab_links'][] = array('action' => 'proc',
									'label' =>  $txt['spmod_procurements'],
									'visible' => allowedTo(array('view_spmod', 'view_spadmin')));
										
	$context['tab_links'][] = array('action' => 'sizes',
									'label' =>  $txt['spmod_lines'],
									'visible' => allowedTo(array('view_spmod', 'view_spadmin')));

	$context['tab_links'][] = array('action' => 'parser',
									'label' =>  $txt['spmod_parser'],
									'visible' => allowedTo(array('view_spmod', 'view_spadmin')));

	$context['tab_links'][] = array('action' => 'myproc',
									'label' =>  $txt['spmod_myproc'],
									'visible' => allowedTo(array('view_spbuy', 'view_spmod', 'view_spadmin')));	
									
	$context['tab_links'][] = array('action' => 'spadmin',
									'label' =>  $txt['spmod_spadmin'],
									'visible' => allowedTo('view_spadmin'));										

	$context['tab_links'][] = array('action' => 'help',
									'label' =>  $txt['spmod_sphelp'],
									'visible' => true);										
									
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'orginfo';	
	$context['sa'] = $_REQUEST['sa'];
	$context['sub_template'] = $_REQUEST['sa'];
	$subActions[$_REQUEST['sa']]();	
	
	
}

function recountItems()
{
	global $smcFunc;
	
	$counts = array();
	$result = $smcFunc['db_query']('','
		SELECT catid
		FROM {db_prefix}spmod_item',
			array(		
				)
			);
	
	while ($row = $smcFunc['db_fetch_assoc']($result))
		if ($row['catid'] != 0)
			$counts[$row['catid']] = (isset($counts[$row['catid']]) ? $counts[$row['catid']] + 1 : 1);
		
	$smcFunc['db_free_result']($result);
	
	foreach ($counts as $key => $value)
		$smcFunc['db_query']('','
			UPDATE {db_prefix}spmod_category
			SET count = {int:value}
			WHERE catid = {int:key}',
			array(
			'value' => $value,
			'key' => $key,	
				)
			);			
}

function list_getSPAdminCount()
{
	global $smcFunc;
	
	$request = $smcFunc['db_query']('', '
		SELECT COUNT(DISTINCT procid)
		FROM {db_prefix}spmod_proc
		WHERE (stopdate >= {int:be}) AND (stopdate <= {int:en}) AND (status LIKE {string:st})',
	array(
		'be' => strtotime($_REQUEST['proc_start']),			
		'en' => strtotime($_REQUEST['proc_stop']),			
		'st' => $_REQUEST['proc_status'],
			)
	);
	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $count;
}

function list_getSPAdminEntries($start, $items_per_page, $sort)
{
	global $smcFunc, $modSettings;
		
	$request = $smcFunc['db_query']('', '
		SELECT DISTINCT p.procid, p.name, p.topicid, p.status, m.real_name, p.orgid, ROUND(SUM(i.price), 2) as summ, ROUND(SUM(i.price)*p.orgpercent/100, 2) as org, p.orgpercent, p.startdate, p.stopdate
		FROM {db_prefix}spmod_proc AS p
		LEFT JOIN {db_prefix}members AS m ON (p.orgid = m.id_member)
		LEFT JOIN {db_prefix}spmod_purchHis AS h ON (p.procid = h.procid)
		LEFT JOIN {db_prefix}spmod_item AS i ON (i.itemid = h.itemid)
		WHERE (p.stopdate >= {int:be}) AND (p.stopdate <= {int:en}) AND (p.status LIKE {string:st})
		GROUP BY p.procid
		ORDER BY ' . $sort . '
		LIMIT ' . $start . ', ' . $items_per_page,
	array(
		'be' => strtotime($_REQUEST['proc_start']),			
		'en' => strtotime($_REQUEST['proc_stop']),	
		'st' => $_REQUEST['proc_status'],
		)
	);
	
	$entries = array();
	if (!isset($modSettings['spmod_commission'])) $modSettings['spmod_commission'] = 0;
	while ($row = $smcFunc['db_fetch_row']($request))
	{		
		$entries[] = array(
			'procid' => $row[0],
			'procname' => $row[1],
			'topicid' => $row[2],
			'status' => $row[3],
			'orgname' => $row[4],
			'orgid' => $row[5],
			'itemsum' => $row[6],
			'orgsum' => $row[7],
			'orgperc' => $row[8],
			'commission' => round($row[6] * $modSettings['spmod_commission']/100, 2),
			'startdate' => date('j.m.Y', $row[9]),
			'stopdate' => date('j.m.Y', $row[10]),
		);
	}
	
	$smcFunc['db_free_result']($request);

	return $entries;
}

function list_getProcCount()
{
	global $smcFunc, $user_info, $txt;

	//Запрашиваем Сами Закупки 
	$request = $smcFunc['db_query']('', '
			SELECT COUNT(procid)
			FROM {db_prefix}spmod_proc
			WHERE orgid = {int:or} AND NOT (status LIKE {string:sc} OR status LIKE {string:sn} OR status LIKE {string:sk})',
		array(
			'or' => $user_info['id'],
			'sc' => $txt['spmod_purchstat_close'],
			'sn' => $txt['spmod_purchstat_wasnt'],
			'sk' => $txt['spmod_purchstat_vocation'],			
		)	
	);

	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $count;
}

function list_getClosedProcCount()
{
	global $smcFunc, $user_info, $txt;

	//Запрашиваем Сами Закупки 
	$request = $smcFunc['db_query']('', '
			SELECT COUNT(procid)
			FROM {db_prefix}spmod_proc
			WHERE orgid = {int:or} AND (status LIKE {string:sc} OR status LIKE {string:sn} OR status LIKE {string:sk})',
		array(
			'or' => $user_info['id'],
			'sc' => $txt['spmod_purchstat_close'],
			'sn' => $txt['spmod_purchstat_wasnt'],
			'sk' => $txt['spmod_purchstat_vocation'],
		)	
	);

	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $count;
}

function list_getProcEntries($start, $items_per_page, $sort)
{
	global $smcFunc, $user_info, $txt;
	
	$request = $smcFunc['db_query']('', '
			SELECT procid, name, description, startdate, stopdate, status, topicid
			FROM {db_prefix}spmod_proc
			WHERE orgid = {int:or} AND NOT (status LIKE {string:sc} OR status LIKE {string:sn} OR status LIKE {string:sk})
			ORDER BY ' . $sort . '
			LIMIT ' . $start . ', ' . $items_per_page,
		array(
			'or' => $user_info['id'],
			'sc' => $txt['spmod_purchstat_close'],
			'sn' => $txt['spmod_purchstat_wasnt'],
			'sk' => $txt['spmod_purchstat_vocation'],			
		)	
	);		
	$entries = array();
	while ($row = $smcFunc['db_fetch_row']($request))
	{
		//..и связь с каталогами
		$linksrequest = $smcFunc['db_query']('', '			
				SELECT catid, name
				FROM {db_prefix}spmod_proccat				
				LEFT JOIN {db_prefix}spmod_category
				USING(catid)
				WHERE procid = {int:pr}',
			array(
				'pr' => $row[0]				
			)	
		);
		$proccats = array();
		$proccatnames = array();
		while ($subrow = $smcFunc['db_fetch_row']($linksrequest))
		{
			$proccats[] = $subrow[0];
			$proccatnames[] = $subrow[1];
		}
		$smcFunc['db_free_result']($linksrequest);		
		
		$entries[] = array(
			'procid' => $row[0],
			'procname' => $row[1],
			'description' => $row[2],
			'startdate' => date('j.m.Y', $row[3]),
			'stopdate' => date('j.m.Y', $row[4]),
			'status' => $row[5],
			'topicid' => $row[6],
			'proccats' =>  implode(", ", $proccats),
			'proccatnames' => implode(", ", $proccatnames),
		);		
	}	
	$smcFunc['db_free_result']($request);
	
	return $entries;
}

function list_getClosedProcEntries($start, $items_per_page, $sort)
{
	global $smcFunc, $user_info, $txt;
	
	$request = $smcFunc['db_query']('', '
			SELECT procid, name, description, startdate, stopdate, status, topicid
			FROM {db_prefix}spmod_proc
			WHERE orgid = {int:or} AND (status LIKE {string:sc} OR status LIKE {string:sn} OR status LIKE {string:sk})
			ORDER BY ' . $sort . '
			LIMIT ' . $start . ', ' . $items_per_page,
		array(
			'or' => $user_info['id'],
			'sc' => $txt['spmod_purchstat_close'],
			'sn' => $txt['spmod_purchstat_wasnt'],
			'sk' => $txt['spmod_purchstat_vocation'],
		)	
	);		
	$entries = array();
	while ($row = $smcFunc['db_fetch_row']($request))
	{
		//..и связь с каталогами
		$linksrequest = $smcFunc['db_query']('', '			
				SELECT catid, name
				FROM {db_prefix}spmod_proccat				
				LEFT JOIN {db_prefix}spmod_category
				USING(catid)
				WHERE procid = {int:pr}',
			array(
				'pr' => $row[0]				
			)	
		);
		$proccats = array();
		$proccatnames = array();
		while ($subrow = $smcFunc['db_fetch_row']($linksrequest))
		{
			$proccats[] = $subrow[0];
			$proccatnames[] = $subrow[1];
		}
		$smcFunc['db_free_result']($linksrequest);		
		
		$entries[] = array(
			'procid' => $row[0],
			'procname' => $row[1],
			'description' => $row[2],
			'startdate' => date('j.m.Y', $row[3]),
			'stopdate' => date('j.m.Y', $row[4]),
			'status' => $row[5],
			'topicid' => $row[6],
			'proccats' =>  implode(", ", $proccats),
			'proccatnames' => implode(", ", $proccatnames),
		);		
	}	
	$smcFunc['db_free_result']($request);
	
	return $entries;
}

function list_getMyProcCount()
{
	global $smcFunc, $user_info;

	$request = $smcFunc['db_query']('', '
		SELECT COUNT(DISTINCT procid)
		FROM {db_prefix}spmod_purchHis
		WHERE userid = {int:us}',
	array(
			'us' => $user_info['id'],
		)
	);
	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $count;
}

function list_getMyProcEntries($start, $items_per_page, $sort)
{
	global $smcFunc, $user_info;

	$request = $smcFunc['db_query']('', '
		SELECT h.procid, p.name, COUNT(h.procid) as itemcount, p.topicid, p.status, IFNULL(u.payment, 0) as payment, IFNULL(h.orgpercent, p.orgpercent) as orgpercent, p.tr, p.tr_mode, SUM(i.price) as summa
		FROM {db_prefix}spmod_purchHis as h
		LEFT JOIN {db_prefix}spmod_proc AS p ON (p.procid = h.procid)
		LEFT JOIN {db_prefix}spmod_userproc AS u ON (u.userid = h.userid AND u.procid = h.procid)
		LEFT JOIN {db_prefix}spmod_item AS i ON i.itemid = h.itemid
		WHERE h.userid = {int:us}
		GROUP BY h.procid
		ORDER BY ' . $sort . '
		LIMIT ' . $start . ', ' . $items_per_page,
	array(
			'us' => $user_info['id'],			
		)
	);
	
	$entries = array();
	while ($row = $smcFunc['db_fetch_row']($request))
	{		
		$tr = round(getTR($row[0], $row[8], $row[7], $row[9], $row[2]), 2);
		$entries[] = array(
			'procid' => $row[0],
			'procname' => $row[1],
			'itemcount' => $row[2],
			'topicid' => $row[3],
			'status' => $row[4],
			'payment' => $row[5],
			'summa' => $row[9],
			'org' => $row[9] / 100 * $row[6],
			'tr' => $tr,
			'vsego' => round($row[9] + $row[9] / 100 * $row[6] + $tr, 2),
		);
	}
	
	$smcFunc['db_free_result']($request);

	return $entries;
}

function list_getGoodsCount()
{
	global $smcFunc, $user_info;
	if (!isset($_REQUEST['catid'])) fatal_error($txt['spmod_nocatid']);
	if (!isset($_REQUEST['good_search']))$_REQUEST['good_search'] = '';
	$request = $smcFunc['db_query']('', '
		SELECT COUNT(itemid)
		FROM {db_prefix}spmod_item
		WHERE catid = {int:ca} AND (name LIKE \'%'.$_REQUEST['good_search'].'%\' OR description LIKE \'%'.$_REQUEST['good_search'].'%\' OR articul LIKE \''.$_REQUEST['good_search'].'\')',
	array(
			'ca' => (int)$_REQUEST['catid'],
		)
	);
	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $count;
}

function list_getGoodsEntries($start, $items_per_page, $sort)
{
	global $smcFunc, $user_info;
	if (!isset($_REQUEST['catid'])) fatal_error($txt['spmod_nocatid']);
	if (!isset($_REQUEST['good_search']))$_REQUEST['good_search'] = '';
	
	$request = $smcFunc['db_query']('', '
		SELECT
			i.itemid, i.name, i.description, i.image, i.price, i.link, i.articul, i.linecount, i.linecaption, i.params
		FROM {db_prefix}spmod_item as i
		WHERE catid = {int:ca} AND (i.name LIKE \'%'.$_REQUEST['good_search'].'%\' OR i.description LIKE \'%'.$_REQUEST['good_search'].'%\' OR i.articul LIKE \''.$_REQUEST['good_search'].'\')
		GROUP BY i.itemid
		ORDER BY ' . $sort . '
		LIMIT ' . $start . ', ' . $items_per_page,
	array(
			'ca' => (int)$_REQUEST['catid'],			
		)
	);	
	
	$entries = array();
	while ($row = $smcFunc['db_fetch_row']($request))
	{		
		$entries[] = array(
			'id' => $row[0],
			'name' => $row[1],
			'descr' => $row[2],
			'img' => $row[3],
			'price' => $row[4],
			'url' => $row[5],
			'art' => $row[6],
			'p1lc' => $row[7],
			'p1c' => $row[8],
			'p1p' => $row[9],
		);
	}
	
	$smcFunc['db_free_result']($request);

	return $entries;
}

function list_getCategoryCount()
{
	global $smcFunc, $user_info;
	
	$request = $smcFunc['db_query']('', '
		SELECT COUNT(catid)
		FROM {db_prefix}spmod_category
		WHERE orgid = {int:or}',
		array(
			'or' => $user_info['id']
		)
	);
	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);
	return $count;
}

function list_getCategoryEntries($start, $items_per_page, $sort)
{
	global $smcFunc, $user_info;
	
	$request = $smcFunc['db_query']('', '
		SELECT
			catid, name, description, image, count, orgid 
		FROM {db_prefix}spmod_category
		WHERE orgid = {int:or}
		GROUP BY catid
		ORDER BY ' . $sort . '
		LIMIT ' . $start . ', ' . $items_per_page,
		array(
			'or' => $user_info['id']
		)
	);
	$entries = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{		
		$entries[] = array(
			'id' => $row['catid'],
			'img' => $row['image'],
			'name' => $row['name'],
			'count' => $row['count'],
		);
	}
	$smcFunc['db_free_result']($request);
	return $entries;
}

function list_getCustomerCount()
{
	global $smcFunc;
	
	$request = $smcFunc['db_query']('', '
		SELECT COUNT(DISTINCT userid)
		FROM {db_prefix}spmod_purchHis
		WHERE procid = {int:pr}',
	array(
			'pr' => $_REQUEST['procid'],
		)
	);
	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);
	return $count;
}

function getTR($procid, $tr_mode, $tr, $summa, $itemcount)
{
	global $smcFunc;	
	
	switch ($tr_mode) 
	{
		//простой процент
		case 1:
			return round($summa * $tr/100, 2);
			break;
		//Делим поровну	
		case 2:
			//return round($tr / $itemcount, 2);
			$request = $smcFunc['db_query']('', '
				SELECT COUNT(DISTINCT userid)
				FROM {db_prefix}spmod_purchHis
				WHERE procid = {int:pr}',
			array(
					'pr' => $_REQUEST['procid'],
				)
			);
			list ($count) = $smcFunc['db_fetch_row']($request);
			return round($tr / $count, 2);
			break;
		//Пропорционально заказу	
		case 3:
			$irequest = $smcFunc['db_query']('', '
				SELECT ROUND(SUM(i.price), 2) as fullsum
				FROM {db_prefix}spmod_purchHis as p
				LEFT JOIN {db_prefix}spmod_item as i on (i.itemid = p.itemid) AND (i.status = 0)
				WHERE p.procid = {int:pr}
				LIMIT 1',
			array(
					'pr' => $procid,
				)
			);
			$irow = $smcFunc['db_fetch_assoc']($irequest);
			$fullsum = $irow['fullsum'];
			$smcFunc['db_free_result']($irequest);
			return round($tr*$summa/$fullsum, 2);
			break;
		//По количеству позиций	
		case 4:	
			$irequest = $smcFunc['db_query']('', '
				SELECT count(i.price) as fullcount
				FROM {db_prefix}spmod_purchHis as p
				RIGHT JOIN {db_prefix}spmod_item as i on (i.itemid = p.itemid) AND (i.status = 0)
				WHERE p.procid = {int:pr}
				LIMIT 1',
			array(
					'pr' => $procid,
				)
			);
			$irow = $smcFunc['db_fetch_assoc']($irequest);
			$fullcount = $irow['fullcount'];
			$smcFunc['db_free_result']($irequest);
			if ($fullcount==0) return 0;
				else
					return round($tr/$fullcount * $itemcount, 2);
			break;	
	}
}			

function list_getCustomerEntries($start, $items_per_page, $sort)
{
	global $smcFunc, $context;

	$request = $smcFunc['db_query']('', '
		SELECT 
			IFNULL(u.payment, 0) as payment, 
			IFNULL(u.paymentdate, 0) as paymentdate, 
			IFNULL(p.orgpercent, z.orgpercent) as orgpercent, 
			z.orgpercent as commonorgpercent, 
			m.real_name as username, 
			o.orgname as orgname, 
			o.orgphone, 
			o.address as orgaddress,
			o.distribution, 
			p.id, 
			p.userid as userid,
			z.tr as tr, 
			IFNULL(p.tr, z.tr) as manualtr,
			z.tr_mode, 
			COUNT(i.itemid) as cnt, 
			ROUND(SUM(i.price), 2) as summ, 
			ROUND(SUM(i.price)*z.orgpercent/100, 2) as org, 
			ROUND(SUM(i.price)*z.bankfee/100, 2) as bank, 
			z.bankfee as bankfee,
			m2.real_name as orgnickname,
			z.name as procname
		FROM {db_prefix}spmod_purchHis as p
		LEFT JOIN {db_prefix}members as m on m.id_member = p.userid
		RIGHT JOIN {db_prefix}spmod_item as i on (i.itemid = p.itemid) AND (i.status = 0)
		LEFT JOIN {db_prefix}spmod_proc as z on z.procid = p.procid
		LEFT JOIN {db_prefix}spmod_orginfo as o on o.orgid = m.id_member
		LEFT JOIN {db_prefix}spmod_userproc as u on u.userid = p.userid and u.procid = p.procid 
		LEFT JOIN {db_prefix}members as m2 on m2.id_member = z.orgid
		WHERE p.procid = {int:pr}
		GROUP BY p.userid
		ORDER BY ' . $sort . '
		LIMIT ' . $start . ', ' . $items_per_page,
		array(
			'pr' => (int)$_REQUEST['procid'],
		)
	);

	$entries = array();
	$context['report_orgpercent'] = 0;
	$context['report_bankfee'] = 0;
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{	
		$true_orgpercent = $row['orgpercent'];
		$context['report_orgpercent'] = $row['commonorgpercent'];
		$context['report_bankfee'] = $row['bankfee'];
		if (isset($row['summ']))  
		{
			$summ = $row['summ'];
			if ($row['tr_mode'] == 5)
				if (isset($row['manualtr'])) $tr = $row['manualtr']; else $tr = 0;
			else $tr = getTR($_REQUEST['procid'], $row['tr_mode'], $row['tr'], $row['summ'], $row['cnt']);
			$org = ROUND($row['summ'] * $true_orgpercent / 100, 2);
			$bank = $row['bank'];				
		} 
		else
		{
			$summ = 0;
			$tr = 0;
			$org = 0;
			$bank = 0;
		}
		$itogo = $summ + $org + $bank + $tr;			
		
		$entries[] = array(
			'real_name' => $row['username'],
			'id' => $row['id'],
			'userid' => $row['userid'],
			'summ' => $summ,
			'org' => $org,
			'cnt' => $row['cnt'],
			'bank' => $bank,
			'tr' => $tr,
			'trmode' => $row['tr_mode'],
			'itogo' => $itogo,
			'orgname' => $row['orgname'],
			'orgphone' => $row['orgphone'],
			'orgaddress' => $row['orgaddress'],
			'distribution' => $row['distribution'],
			'orgpercent' => $true_orgpercent,
			'payment' => $row['payment'],
			'paymentdate' => $row['paymentdate'],
		);

		$context['report_real_name'][] = $row['username'];
		$context['report_userid'][] = $row['userid'];
		$context['report_summ'][] = $summ;
		$context['report_org'][] = $org;
		$context['report_cnt'][] = $row['cnt'];
		$context['report_bank'][] = $bank;
		$context['report_tr'][] = $tr;
		$context['report_itogo'][] = $itogo;
		$context['report_distr'][] = $row['distribution'];
		$context['report_count'][] = $row['cnt'];
		$context['report_payment'][] = $row['payment'];		
		$context['report_orgname'][] = $row['orgname'];	
		$context['report_orgnickname'][] = $row['orgnickname'];	
		$context['report_procname'][] = $row['procname'];	
	}
	$smcFunc['db_free_result']($request);
	return $entries;
}

function SetAdminProcSettings()
{
	global $modSettings, $context, $smcFunc;
	
	//Некоторые администраторские настройки закупки
	if (!isset($modSettings['spmod_maxpercent'])) $modSettings['spmod_maxpercent'] = 0;
	$context['sp_percent'] = array();
	for ($i = 0; $i <= (int)$modSettings['spmod_maxpercent']; $i++) {
		$context['sp_percent'][] += $i;
	}
	
	if (!isset($modSettings['spmod_spcats'])||(str_replace(" ","",$modSettings['spmod_spcats'])==''))
	{
		$request = $smcFunc['db_query']('', '
				SELECT name, id_board, member_groups
				FROM {db_prefix}boards',
				array()
			);		
	}
	else
	{
		$sp_cats = explode(",", $modSettings['spmod_spcats']);
		$catscount = count($sp_cats);
		
		$i = 1; $where = 'WHERE id_cat = {int:id'; 
		if (!empty($sp_cats)) foreach ($sp_cats as $sp_cat)
		{
			$where = $where . $i . '}';
			if ($i < $catscount) $where = $where . ' or id_cat = {int:id';
			$key = 'id' . $i;
			$ids[$key] = (int)$sp_cat;
			$i++;
		}
		$request = $smcFunc['db_query']('', '
				SELECT name, id_board, member_groups
				FROM {db_prefix}boards ' . $where,
			$ids
		);		
	}
	while ($row = $smcFunc['db_fetch_row']($request))
	{
		//Доступны ли эти разделы пользователю, проверяем права
		//if ($context['user']['is_admin'] || count(array_intersect($user_info['groups'], explode(",", $row[2]))) > 0)
			$context['sp_forum_categorylist'][] = array(
				'board_name' => $row[0],
				'id_board' => $row[1]
			);		
	}
	$smcFunc['db_free_result']($request);	
}

function GetCatsByUserID()
{
	global $smcFunc, $user_info, $context;

	$request = $smcFunc['db_query']('', '
			SELECT catid, name, image, count 
			FROM {db_prefix}spmod_category
			WHERE orgid = {int:or}',
		array(
			'or' => $user_info['id']
		)			
	);		
	while ($row = $smcFunc['db_fetch_row']($request))
	{
		$context['spmod_cats'][] = array(
			'catid' => $row[0],
			'name' => $row[1],
			'image' => $row[2],
			'count' => $row[3],
		);
		$catnames[$row[0]] = $row[1];		
	}
	$smcFunc['db_free_result']($request);
	if (isset($catnames)) return $catnames;
}

function GetParamsByUserID()
{
	global $smcFunc, $user_info, $context;

	$request = $smcFunc['db_query']('', '
			SELECT paramid, name, caption, params, linecount 
			FROM {db_prefix}spmod_itemparam
			WHERE orgid = {int:or}',
		array(
			'or' => $user_info['id']
		)			
	);		
	while ($row = $smcFunc['db_fetch_row']($request))
	{
		$context['spmod_params'][] = array(
			'paramid' => $row[0],
			'name' => $row[1],
			'caption' => $row[2],
			'params' => $row[3],
			'linecount' => $row[4],
		);		
	}
	$smcFunc['db_free_result']($request);	
}

//Контроллер зоны каталогов		
function SPmodCategories()
{
	global $smcFunc, $context, $user_info, $sourcedir, $scripturl, $txt;

    isAllowedTo('view_spmod'); 	
	
	if (isset($_REQUEST['do']))
	{
		checkSession();
		
		//Если передаётся новый каталог, то создать его
		if (($_REQUEST['do']=='add')&&(isset($_REQUEST['cat_name'])))
		{
			if (!isset($_REQUEST['cat_user'])) $_REQUEST['cat_user'] = 0;
			CreateNewCat($_REQUEST['cat_name'], $_REQUEST['cat_user']);
		}
		//Удалить каталог(и)
		if (($_REQUEST['do']=='del')&&(isset($_REQUEST['catid'])))
		{		
			if (!is_array($_REQUEST['catid']))
				$cats = array($_REQUEST['catid']);
			else
				$cats = array_unique($_REQUEST['catid']);			
			foreach ($cats as $k => $v)
				$cats[$k] = (int)$v;
				
			$smcFunc['db_query']('', '
					DELETE 
					FROM {db_prefix}spmod_category
					WHERE catid IN ({array_int:id}) AND orgid = {int:or}',
				array(
					'id' => $cats,
					'or' => $user_info['id']
				)
			);	
					
			//И все товары из этого каталога
			$smcFunc['db_query']('', '
					DELETE 
					FROM {db_prefix}spmod_item
					WHERE catid IN ({array_int:id})',
				array(
					'id' => $cats,
				)
			);			
		}
		redirectexit($scripturl.'?action=spmod;sa=spcat');
	}
	else
	{
		
		$context['page_title'] = $txt['spmod_cats'];
		$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));
	
		$context['linktree'][] = array(
			'url' => $scripturl. '?action=spmod;sa=spcat',
			'name' => $context['page_title'],
		);		
			
		$listOptions = array(
			'id' => 'cat_list',
			'items_per_page' => 20,
			'title' => $txt['spmod_catslist'],
			'no_items_label' => $txt['spmod_nocats'],
			'base_href' => $scripturl . '?action=spmod;sa=spcat',
			'default_sort_col' => 'name',
			'get_items' => array(
				'function' => 'list_getCategoryEntries',
			),
			'get_count' => array(
				'function' => 'list_getCategoryCount',
			),
			'columns' => array(
				'name' => array(
					'header' => array(
						'value' => $txt['spmod_catname'],
					),
					'data' => array(
						'function' => create_function('$entry', '
							global $scripturl;
							return \'<a href="\' . $scripturl . \'?action=spmod;sa=goods;catid=\' . $entry[\'id\'] . \'">\' . $entry[\'name\'] . \'</a>\';'
						),	
					),
					'sort' => array(
						'default' => 'name',
						'reverse' => 'name DESC',
					),				
				),
				'count' => array(
					'header' => array(
						'value' => $txt['spmod_itemcount'],
					),
					'data' => array(
						'db' => 'count',
						'style' => 'text-align: center;',
					),				
					'sort' => array(
						'default' => 'count DESC',
						'reverse' => 'count',
					),
				),
				'edit' => array(
					'header' => array(
						'value' => $txt['spmod_edit'],
					),
					'data' => array(
						'function' => create_function('$entry', '
								global $scripturl; 
								return \'<a href="\' . $scripturl . \'?action=spmod;sa=editcat;catid=\'. $entry[\'id\'] . \'">'.$txt['spmod_edit'].'</a>\';'
						),
						'style' => 'text-align: center;',
					),	
				),			
				'download' => array(
					'header' => array(
						'value' => $txt['spmod_download'],
					),
					'data' => array(
						'function' => create_function('$entry', '
								global $scripturl; 
								return \'<a href="\'. $scripturl . \'?action=spmod;sa=toxml;catid=\' . $entry[\'id\'] . \';sesc=' . $context['session_id'] . '">'.$txt['spmod_download'].'</a>\';'					
						),
						'style' => 'text-align: center;',
					),	
				),
				'check' => array(
					'header' => array(
						'value' => '<input type="checkbox" onclick="invertAll(this, this.form);" class="input_check" />',
					),
					'data' => array(
						'function' => create_function('$entry', '

							return \'<input type="checkbox" name="catid[]" value="\' . $entry[\'id\'] . \'" class="input_check" />\';
						'),
						'class' => 'windowbg',
						'style' => 'text-align: center',
					),
				),			
			),	
		);

		require_once($sourcedir . '/Subs-List.php');
		createList($listOptions);																											
	}
}

//Контроллер зоны редактирования каталога
function SPmodEditCat()
{
	global $context, $smcFunc, $txt, $scripturl, $user_info;

	isAllowedTo('view_spmod');
	
	if (isset($_REQUEST['catid']))
	{
		if ((isset($_REQUEST['do']))&&(isset($_REQUEST['cat_name'])))
		{
			if ($_REQUEST['do']=='save')
			{
				if (!isset($_REQUEST['cat_user'])) $_REQUEST['cat_user'] = 0;
				$smcFunc['db_insert']('replace',
					'{db_prefix}spmod_category',
					array(
						'catid' => 'int', 'name' => 'string-255', 'orgid' => 'int', 'usercat' => 'int'
					),
					array(
						$_REQUEST['catid'], 
						$smcFunc['htmlspecialchars']($_REQUEST['cat_name'], ENT_QUOTES),
						$user_info['id'],
						$_REQUEST['cat_user'],
					),
					array('catid')
				);

                //Обновить параметры у всех товаров в каталоге
		        if (isset($_REQUEST['good_param1']) && $_REQUEST['good_param1'] != 0)
				{
					$request = $smcFunc['db_query']('', '
							SELECT caption, params, linecount 
							FROM {db_prefix}spmod_itemparam
							WHERE paramid = {int:pa1}
							LIMIT 1',
						array(
							'pa1' => (int)$_REQUEST['good_param1'],
						)			
					);		
					while ($row = $smcFunc['db_fetch_row']($request))
					{
						$smcFunc['db_query']('','
							UPDATE {db_prefix}spmod_item
							SET 
							param1 = {int:pa1},
							linecount = {int:lc},
							params = {string:pa},
							linecaption = {string:ca}
							WHERE 
							catid = {int:cid}',
						array(
							'pa1' => $_REQUEST['good_param1'],
							'cid' => $_REQUEST['catid'],
							'lc' => $row[2],	
							'pa' => $row[1],
							'ca' => $row[0],
							)
						);		
					}
					$smcFunc['db_free_result']($request);					
				}
				recountItems(); //Тяжелый запрос - ОПТИМИЗИРОВАТЬ!!!
				redirectexit($scripturl.'?action=spmod;sa=spcat');		
			}
		}
		else
		{			
			$context['page_title'] = $txt['spmod_cats'];
			$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));
		
			$context['linktree'][] = array(
				'url' => $scripturl. '?action=spmod;sa=spcat',
				'name' => $context['page_title'],
			);
			
			$request = $smcFunc['db_query']('', '
					SELECT name, usercat 
					FROM {db_prefix}spmod_category
					WHERE catid = {int:ca}
					LIMIT 1',
				array(
					'ca' => $_REQUEST['catid']
				)			
			);		
			$row = $smcFunc['db_fetch_row']($request);
			$smcFunc['db_free_result']($request);
			$context['spmod_curname'] = $row[0];			
			$context['spmod_usercat'] = $row[1];			
			$context['spmod_curid'] = $_REQUEST['catid'];
			GetParamsByUserID();
		}
	}
	else
		fatal_error($txt['spmod_nocatid']);	
}

function ResizeSigImage($source, $dest, $max_width, $max_height, &$newDest)
{
	global $sourcedir, $context, $sigInfo;
	
	if (!isset($source) || $source == '')
		return false;
		
	require_once($sourcedir.'/Subs-Graphics.php');

	$default_formats = array(
		'1' => 'gif',
		'2' => 'jpeg',
		'3' => 'png',
		'6' => 'bmp',
		'15' => 'wbmp'
	);

	$testGD = get_extension_funcs('gd');

	if (empty($testGD))
		return false;

	$gd2 = in_array('imagecreatetruecolor', $testGD) && function_exists('imagecreatetruecolor');
	unset($testGD);

	@ini_set('memory_limit', '48M');

	$success = false;
	$animated = false;
	$sizes = @getimagesize($source);

	if (empty($sizes))
		return false;

	if (!in_array($default_formats[$sizes[2]], $default_formats))
		return false;
				
	$width = (int) $sizes[0];		
	$height = (int) $sizes[1];

	if (empty($max_width))
		$max_width = $width;
	if (empty($max_height))
		$max_height = $height;

	$x_ratio = $max_width / $width;
	$y_ratio = $max_height / $height;
		
	if( ($width <= $max_width) && ($height <= $max_height) ){
		$tn_width = $width;
		$tn_height = $height;
	}elseif (($x_ratio * $height) < $max_height){
			$tn_height = ceil($x_ratio * $height);
			$tn_width = $max_width;
	}else{
			$tn_width = ceil($y_ratio * $width);
			$tn_height = $max_height;
	}

	if (isset($default_formats[$sizes[2]]) && function_exists('imagecreatefrom' . $default_formats[$sizes[2]]))
	{
		if ($sizes[2] == 6) 
			$src_img = imagecreatefrombitmap($source);
		elseif ($sizes[2] == 1 && is_ani($source)) { 
			if ($width <= $max_width && $height <= $max_height)
			{
				$animated = true;
				$success = true;
				$sigInfo['sig_fileext'] = 'gif';
				$sigInfo['sig_mimetype'] = 'image/gif';
			}
			else 
				$src_img = imagecreatefromgif($source);
		} 
		else {
			$imagecreatefrom = 'imagecreatefrom' . $default_formats[$sizes[2]];
			$src_img = @$imagecreatefrom($source);
		}
	}
	else 
	 	return false;

	if (!$animated)
	{	
		if ($sizes[2] == 3 || $sizes[2] == 1) {
			$transp = $alpha = $trn = false;
			$trn = imagecolortransparent($src_img);
			$alpha = $default_formats[$sizes[2]] == 'png' && (((ord(@file_get_contents($source, false, null, 25, 1)) & 6) & 4) == 4);
			$single = $trn >= 0 && $default_formats[$sizes[2]] != 'gif';
			$transp = $trn >= 0 || $alpha;
			
			$tmp = imagecreatetruecolor($tn_width,$tn_height);
			
			if ($transp)
			setTransparent($src_img, $tmp, $trn, $single);
	
			$resizeFunc = 'imagecopy' . (empty($single) ? 'resampled' : 'resized');
			$resizeFunc($tmp,$src_img,0,0,0,0,$tn_width, $tn_height,$width,$height);
		
			if ($transp) {
				if ($alpha && $tmp == $src_img)
					imagesavealpha($tmp, true);
			}		
			imagepng($tmp, $dest);
			$sigInfo['sig_fileext'] = 'png';
			$sigInfo['sig_mimetype'] = 'image/png';	
			$success = true;
		}
		else
		{
			if ($sizes[2] == 6 || $sizes[2] == 15) 
			{			
				$tmp = imagecreatetruecolor($tn_width, $tn_height);
				imagecopyresampled($tmp, $src_img, 0, 0, 0, 0,$tn_width, $tn_height,$width, $height);
	
				imagepng($tmp, $dest);
				$sigInfo['sig_fileext'] = 'png';
				$sigInfo['sig_mimetype'] = 'image/png';
				$success = true;			
			}
			else 
			{ 
				$tmp = imagecreatetruecolor($tn_width,$tn_height);
				imagecopyresampled($tmp,$src_img,0,0,0,0,$tn_width, $tn_height,imagesx($src_img), imagesy($src_img));
						
				imagejpeg($tmp, $dest, 100);
				$sigInfo['sig_fileext'] = 'jpg';
				$sigInfo['sig_mimetype'] = 'image/jpeg';
				$success = true;			
			}
		}	
		if(!empty($tmp))
			imagedestroy($tmp);
		if (!empty($src_img))
			imagedestroy($src_img);	
	}

	$newDest = $dest . $sigInfo['sig_fileext'];
	
	if ($animated && $success) {
		if (move_uploaded_file($source, $newDest) && @chmod($newDest, 0644))
			return true;
	}
	
	if ($success) {
		if (@rename($dest, $newDest) && @chmod($newDest, 0644))
			return true;
		else
			return false;
	} else
		return false;
}

function CheckGoodParams()
{	
	global $txt, $boardurl, $user_info;
	
	//Загружаем 
	if (isset($_FILES['good_fileimg']['name']) && $_FILES['good_fileimg']['name'] != '')
	{
		$orginalfilename = $_FILES['good_fileimg']['name'];					
		$sig_id = uniqid(strval($user_info['id']));
		$max_width = 1000;
		$max_height = 1000;
		$folderpath = 'SPMod/images/';
		if (!ResizeSigImage($_FILES['good_fileimg']['tmp_name'],  $folderpath . $sig_id, $max_width, $max_height, $itemimg)) {
			fatal_error($txt['spmod_imgloaderror'], false);
		}
	} else 
	{
		if (isset($_REQUEST['good_img']) && !empty($_REQUEST['good_img'])) 
		{	
			$itemimg = $_REQUEST['good_img'];
		} else $itemimg = $boardurl . '/SPMod/images/sp/korob.png';						
	}
	
	if (!isset($_REQUEST['good_name'])) fatal_error($txt['spmod_nogoodname']);
		else
		{
			$_REQUEST['good_name'] = trim($_REQUEST['good_name']);
			if (empty($_REQUEST['good_name'])) fatal_error($txt['spmod_nogoodname']);
				else $pr['itemname'] = $_REQUEST['good_name'];
		}
	if (!isset($_REQUEST['good_descr']))$pr['itemdescr'] = '';
		else $pr['itemdescr'] = $_REQUEST['good_descr'];
	if (!isset($_REQUEST['good_price'])) fatal_error($txt['spmod_nogoodprice']);
		else $pr['itemprice'] = floatval(str_replace(array(',', ' '), array('.', ''), $_REQUEST['good_price']));
	if (!isset($_REQUEST['good_link']))$pr['itemlink'] = '';
		else $pr['itemlink'] = $_REQUEST['good_link'];
	if (!isset($_REQUEST['good_articul']))$pr['itemarticul'] = '';
		else $pr['itemarticul'] = $_REQUEST['good_articul'];				
	if (!isset($_REQUEST['good_param1']))$pr['itemparam1'] = 0;
		else $pr['itemparam1'] = $_REQUEST['good_param1'];
	if (!isset($_REQUEST['good_param2']))$pr['itemparam2'] = 0;
		else $pr['itemparam2'] = $_REQUEST['good_param2'];		
	CheckParamCount();
	if (!isset($_REQUEST['param_linecount']))$pr['itemlinecount'] = 0;
		else $pr['itemlinecount'] = $_REQUEST['param_linecount'];			
	if (!isset($_REQUEST['param_param']))$pr['itemparams'] = '';
		else $pr['itemparams'] = $_REQUEST['param_param'];
	if (!isset($_REQUEST['param_caption']))$pr['itemlinecaption'] = '';
		else $pr['itemlinecaption'] = $_REQUEST['param_caption'];
	$pr['itemimg'] = $itemimg;	
	return $pr;	
}

//Контроллер зоны товаров
function SPModGoods()
{
	global $smcFunc, $context, $sourcedir, $scripturl, $txt;
	if (isset($_REQUEST['do']))
	{
		isAllowedTo(array('view_spbuy', 'view_spmod', 'view_spadmin'));
		//Если передаётся новый товар, то создать его
		if ($_REQUEST['do']=='add')
		{			
			$pr = CheckGoodParams();
			$smcFunc['db_insert']('',
				'{db_prefix}spmod_item',
				array(
					'name' => 'string-255', 
					'description' => 'string-255', 
					'image' => 'string-255', 
					'price' => 'float', 
					'catid' => 'int',
					'link' => 'string-255', 
					'articul' => 'string-255',
					'param1' => 'int',
					'param2' => 'int',
					'linecount' => 'int',
					'params' => 'string',
					'linecaption' => 'string-255',
				),
				array(
					 $smcFunc['htmlspecialchars']($_REQUEST['good_name'], ENT_QUOTES), 
					 $smcFunc['htmlspecialchars']($pr['itemdescr'], ENT_QUOTES),
					 $pr['itemimg'], $pr['itemprice'], $_REQUEST['catid'],
					 $smcFunc['htmlspecialchars']($pr['itemlink'], ENT_QUOTES),
					 $pr['itemarticul'], $pr['itemparam1'], $pr['itemparam2'],
					 $pr['itemlinecount'], $pr['itemparams'], $pr['itemlinecaption'],
				),
				array('')
			);	
			
			// Увеличить счетчик в категориях
			$smcFunc['db_query']('', '
				UPDATE {db_prefix}spmod_category
				SET count = count + 1
				WHERE catid = {int:id}',
				array(
					'id' => $_REQUEST['catid'],
				)
			);	
			if (allowedTo('view_spmod'))
				redirectexit($scripturl.'?action=spmod;sa=goods;catid='.$_REQUEST['catid']);
			else redirectexit($_SERVER["HTTP_REFERER"]);
		}
	
		//Удалить товар(ы)
		if (($_REQUEST['do']=='del')&&(isset($_REQUEST['goodid'])))
		{					
			if (!is_array($_REQUEST['goodid']))
				$goods = array($_REQUEST['goodid']);
			else
				$goods = array_unique($_REQUEST['goodid']);			
			foreach ($goods as $k => $v)
				$goods[$k] = (int)$v;
			
			$request = $smcFunc['db_query']('', '
					SELECT catid
					FROM {db_prefix}spmod_item
					WHERE itemid IN ({array_int:it})
					LIMIT 1',
				array(
						'it' => $goods,
					)
				);			
			$row = $smcFunc['db_fetch_row']($request);
			$smcFunc['db_free_result']($request);				
			
			$smcFunc['db_query']('', '
					DELETE 
					FROM {db_prefix}spmod_item
					WHERE itemid IN ({array_int:it})',
				array(
					'it' => $goods,
				)
			);	

			// Уменьшить счетчик в категориях
			$smcFunc['db_query']('', '
				UPDATE {db_prefix}spmod_category
				SET count = count - {int:co}
				WHERE catid = {int:ca}',
				array(
					'ca' => $row[0],
					'co' => count($goods),
				)
			);			
			redirectexit($scripturl.'?action=spmod;sa=goods;catid='.$row[0]);
		}				
	}
	else
	{		
		isAllowedTo('view_spmod');
		
		$context['page_title'] = $txt['spmod_goods'];
		$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));
	
		$context['linktree'][] = array(
			'url' => $scripturl. '?action=spmod;sa=goods',
			'name' => $context['page_title'],
		);
			
		$firstcatind = GetCatsByUserID();
		//Если переходим по кнопке "Товары", то отобразить товары из первого каталога орга
		if (!isset($_REQUEST['catid'])) 
		{
			if (isset($firstcatind)) $_REQUEST['catid'] = key($firstcatind);
				else fatal_error($txt['spmod_nocats']);
		} 
		if (!isset($_REQUEST['catname'])) $_REQUEST['catname'] = $_REQUEST['catid'];
		$listOptions = array(
			'id' => 'good_list',
			'items_per_page' => 10,
			'title' => $txt['spmod_itemlist'] . ' "' . $_REQUEST['catname'] . '"',
			'no_items_label' => $txt['spmod_noitems'],
			'base_href' => $scripturl . '?action=spmod;sa=goods;catid='.$_REQUEST['catid'],
			'default_sort_col' => 'name',
			'get_items' => array(
				'function' => 'list_getGoodsEntries',
			),
			'get_count' => array(
				'function' => 'list_getGoodsCount',
			),
			'columns' => array(
				'check' => array(
					'header' => array(
						'value' => '<input type="checkbox" onclick="invertAll(this, this.form);" class="input_check" />',
					),
					'data' => array(
						'function' => create_function('$entry', '
							return \'<input type="checkbox" name="goodid[]" value="\' . $entry[\'id\'] . \'" class="input_check" />\';
						'),
						'class' => 'windowbg',
						'style' => 'text-align: center',
					),
				),
				'image' => array(	
					'header' => array(
						'value' => $txt['spmod_photo'],
					),
					'data' => array(
						'function' => create_function('$entry', '
							return \'<img height="80" src="\'.$entry[\'img\'].\'" alt="'.$txt['spmod_jointpurchases'].'" />\';'
						),	
						'style' => 'text-align: center; background: white;',
					),				
				),
				'name' => array(	
					'header' => array(
						'value' => $txt['spmod_description'],
					),
					'data' => array(
						'function' => create_function('$entry', '
							global $scripturl, $context, $txt;
							if (isset($entry[\'p1p\']) && !empty($entry[\'p1p\']))
							{
								$dp = $txt[\'spmod_extparams\'];
								if (isset($entry[\'p1c\'])) $dp = $dp . $entry[\'p1c\'];
							}
							else $dp = \'\';		
							
							return \'<strong><a href="\'.$entry[\'url\'].\'" target="_blank">\'.$entry[\'name\'].\'</a></strong><br />
							<i>\'.$entry[\'descr\'].\'</i>
							<br />
							\'.$txt[\'spmod_articul\'].\': \' . $entry[\'art\'] . \'
							<br />
							\'.$txt[\'spmod_price\'].\': \' . $entry[\'price\'] . \' \' . $txt[\'spmod_currency\'] . \'
							<br />\' . $dp .\'
							<br /><a href="\'. $scripturl. \'?action=spmod;sa=editgood;goodid=\'. $entry[\'id\'] .\'">'.$txt['spmod_edit'].'</a>
							<br />
							<a href="\'. $scripturl. \'?action=spmod;sa=goods;catid=\'.$context[\'spmod_curcat\'] .\';do=del;goodid=\'.$entry[\'id\'] .\';sesc=' . $context['session_id'] . '" onclick="return confirm(\\\''.$txt['spmod_itemdelconf'].' \\\');">'.$txt['spmod_delete'].'</a>
							\';'
						),	
						'style' => 'text-align: left;',
					),			
					'sort' => array(
						'default' => 'i.name',
						'reverse' => 'i.name DESC',
					),				
				),
			),	
		);

		GetParamsByUserID();
		$context['spmod_curcat'] = $_REQUEST['catid'];
		if (isset($_REQUEST['catname']))
			$context['spmod_curname'] = $_REQUEST['catname'];
		else 
			$context['spmod_curname'] = $_REQUEST['catid'];		
		
		require_once($sourcedir . '/Subs-List.php');
		createList($listOptions);	
	}
}

function proc_param_check()
{
	global $txt, $modSettings;
	
	$proc_param = array();
	if (!isset($_REQUEST['proc_name'])) fatal_error($txt['spmod_noprocname']);
		else $proc_param['procname'] = $_REQUEST['proc_name'];		
	if (!isset($_REQUEST['proc_descr'])) $proc_param['procdescr'] = '';
		else $proc_param['procdescr'] = $_REQUEST['proc_descr'];
	if (!isset($_REQUEST['proc_banner'])) $proc_param['procbanner'] = '';
		else $proc_param['procbanner'] = $_REQUEST['proc_banner'];		
	if (!isset($_REQUEST['proc_stop']))$proc_param['procstop'] = time();
		else $proc_param['procstop'] = $_REQUEST['proc_stop'];
	if (!isset($_REQUEST['proc_status']))$proc_param['procstatus'] = $txt['spmod_purchstat_open'];
		else $proc_param['procstatus'] = $_REQUEST['proc_status'];				
	if (!isset($_REQUEST['proc_min'])) $proc_param['procmin'] = 0;
		else $proc_param['procmin'] = floatval(str_replace(',', '.', $_REQUEST['proc_min']));				
	if (!isset($_REQUEST['proc_orgpercent']))$proc_param['procproc'] = 0;
		else $proc_param['procproc'] = $_REQUEST['proc_orgpercent'];
	if (!isset($_REQUEST['proc_website']))$proc_param['procwebsite'] = '';
		else $proc_param['procwebsite'] = $_REQUEST['proc_website'];		
	if (!isset($_REQUEST['proc_forum_category']) || strcasecmp($proc_param['procstatus'], $txt['spmod_purchstat_close']) == 0 || strcasecmp($proc_param['procstatus'], $txt['spmod_purchstat_vocation']) == 0 || strcasecmp($proc_param['procstatus'], $txt['spmod_purchstat_wasnt']) == 0) $proc_param['proc_forum_category'] = $modSettings['spmod_sparchive'];
		else $proc_param['proc_forum_category'] = $_REQUEST['proc_forum_category'];			
	if (!isset($_REQUEST['proc_topic'])) fatal_error($txt['spmod_notopicid']);
		else $proc_param['proctopic'] = $_REQUEST['proc_topic'];
	if (!isset($_REQUEST['proc_fee']))$proc_param['procfee'] = 0;
		else $proc_param['procfee'] = floatval(str_replace(',', '.', $_REQUEST['proc_fee']));
	if (!isset($_REQUEST['proc_tr']))$proc_param['proctr'] = 0;
		else $proc_param['proctr'] = floatval(str_replace(',', '.', $_REQUEST['proc_tr']));
	if (!isset($_REQUEST['proc_tr_mode']))$proc_param['proctrmode'] = 0;
		else $proc_param['proctrmode'] = $_REQUEST['proc_tr_mode'];
	if (!isset($_REQUEST['proc_minsum_mode']))$proc_param['procminsummode'] = 1;
		else $proc_param['procminsummode'] = $_REQUEST['proc_minsum_mode'];	
	if (!isset($_REQUEST['proc_buyout']))$proc_param['procbuyout'] = 1;
		else $proc_param['procbuyout'] = $_REQUEST['proc_buyout'];		
	return $proc_param;	
}

function CreateOrUpdateProcTopic($proc_params, $proc_id, $topic_id = null, $buyout_number = 1)
{
	global $smcFunc, $context, $txt, $user_info, $scripturl, $modSettings, $sourcedir; 
	
	require_once('Sources/Subs-Post.php');

	$request = $smcFunc['db_query']('', '
			SELECT orgname, orgphone
			FROM {db_prefix}spmod_orginfo
			WHERE orgid = {int:or}',
		array(
			'or' => $user_info['id']
		)	
	);		
	$row = $smcFunc['db_fetch_row']($request);
	$orgname = $row[0];
	$orgphone = $row[1];
	$smcFunc['db_free_result']($request);
	$subject = $proc_params['procname'];
	$catlist = '';
	if (!empty($context['spmod_cats']))
	foreach($context['spmod_cats'] as $spmod_cat)
		if (isset($_REQUEST['groups']) && in_array($spmod_cat['catid'], $_REQUEST['groups']))  			
			$catlist = $catlist . '[url=' . $scripturl . '?action=spmod;sa=buys;procid=' . $proc_id . ';catname=' . $spmod_cat['name'] . ';catid=' . $spmod_cat['catid'] . ']' . $spmod_cat['name'] . '[/url]
';

	if (isset($modSettings['spmod_proctemplate']))
	{
		$tr = $proc_params['proctr'];
		switch ($proc_params['proctrmode']) {
		case 1:
			$trmode = $tr . $txt['spmod_trmode1'];
			break;
		case 2:
			$trmode = $tr . $txt['spmod_currency'] . $txt['spmod_trmode2'];
			break;
		case 3:
			$trmode = $tr . $txt['spmod_currency'] . $txt['spmod_trmode3'];
			break;
		case 4:
			$trmode = $tr . $txt['spmod_currency'] . $txt['spmod_trmode4'];
			break;	
		case 5:
			$trmode = $txt['spmod_trmode5'];
			break;			
		}
		switch ($proc_params['procminsummode']) {
		case 1:
			$minmode = $txt['spmod_p_minsum'] . ': ' . $proc_params['procmin'] . $txt['spmod_currency'];
			break;
		case 2:
			$minmode = $txt['spmod_p_mincount'] . ': ' . $proc_params['procmin'];
			break;
		}		
		//Заполняем по шаблону
		$sign = array('{name}', '{phone}', '{satus}', '{percent}', '{bank}', '{tr}', '{trmode}', '{website}', '{stop}', '{min}', '{title}', '{descr}', '{catalogs}', '{table}', '{minmode}');
		$orign = array('[spon]'. $orgname . '[/spon]', '[spph]' . $orgphone . '[/spph]', '[spst]' . $proc_params['procstatus'] . '[/spst]', '[sppc]' . $proc_params['procproc'] . '[/sppc]', '[spfe]' . $proc_params['procfee'] . '[/spfe]',  '[sptr]' . $tr . '[/sptr]', '[sptm]' . $trmode . '[/sptm]',  '[spws]' . $proc_params['procwebsite'] . '[/spws]', '[spsp]' . $proc_params['procstop'] . '[/spsp]',  '[spmi]' . $proc_params['procmin'] . '[/spmi]',  '[sppn]' . $proc_params['procname'] . '[/sppn]',  '[sppd]' . $proc_params['procdescr'] . '[/sppd]', '[spcl]' . $catlist . '[/spcl]', '[sp]' . $proc_id . '[/sp]', '[spmm]' . $minmode . '[/spmm]');	
		$message = str_replace($sign, $orign, $modSettings['spmod_proctemplate']);
	}
	else
	{
		//Если шаблон не задан, то заполняем основные параметры закупки
		$message = '[color=blue][b]' . $proc_params['procname'] . '[/b][/color]' . '
' . '[i]' . $proc_params['procdescr'] . '[/i]
' . $txt['spmod_t_orgname'] . ': ' . $orgname . '
' . $txt['spmod_t_orgphonenumber'] . $orgphone . '
' . $txt['spmod_t_orgperc'] . '[color=red]' . $proc_params['procproc'] . '%[/color] ';
	$message = $message . '
	
[b]' . $txt['spmod_t_catlist'] . '[/b]

' . $catlist . '
		
[center][b]' . $txt['spmod_t_table'] . '[/b][/center]
[sp]' . $proc_id . '[/sp]';
	}
	preparsecode($message);
	//Тема уже создана, обновляем первое сообщение
	if (isset($topic_id))
	{	
		require_once($sourcedir . '/MoveTopic.php');
		moveTopics(array($topic_id), $proc_params['proc_forum_category']);
		$request = $smcFunc['db_query']('', '
				SELECT t.id_first_msg, m.body
				FROM {db_prefix}topics as t
				LEFT JOIN {db_prefix}messages as m on m.id_msg = t.id_first_msg
				WHERE t.id_topic = {int:to}',
			array(
				'to' => $topic_id,			
			)	
		);		
		$row = $smcFunc['db_fetch_row']($request);
		$msg_id = $row[0];
		$body = $row[1];
		$smcFunc['db_free_result']($request);
		
		preg_match_all("#\[spon\](.*)\[/spon\]#is", $body, $spon);
		preg_match_all("#\[spph\](.*)\[/spph\]#is", $body, $spph);
		preg_match_all("#\[spst\](.*)\[/spst\]#is", $body, $spst);
		preg_match_all("#\[sppc\](.*)\[/sppc\]#is", $body, $sppc);
		preg_match_all("#\[spfe\](.*)\[/spfe\]#is", $body, $spfe);
		preg_match_all("#\[sptr\](.*)\[/sptr\]#is", $body, $sptr);		
		preg_match_all("#\[sptm\](.*)\[/sptm\]#is", $body, $sptm);
		preg_match_all("#\[spws\](.*)\[/spws\]#is", $body, $spws);
		preg_match_all("#\[spsp\](.*)\[/spsp\]#is", $body, $spsp);
		preg_match_all("#\[spmi\](.*)\[/spmi\]#is", $body, $spmi);
		preg_match_all("#\[sppn\](.*)\[/sppn\]#is", $body, $sppn);
		preg_match_all("#\[sppd\](.*)\[/sppd\]#is", $body, $sppd);
		preg_match_all("#\[spcl\](.*)\[/spcl\]#is", $body, $spcl);
		preg_match_all("#\[spmm\](.*)\[/spmm\]#is", $body, $spmm);
		if (!isset($spon[0][0])) $spon[0][0] = '';
		if (!isset($spst[0][0])) $spst[0][0] = '';
		if (!isset($spst[0][0])) $spst[0][0] = '';
		if (!isset($sppc[0][0])) $sppc[0][0] = '';
		if (!isset($spfe[0][0])) $spfe[0][0] = '';
		if (!isset($sptr[0][0])) $sptr[0][0] = '';
		if (!isset($sptm[0][0])) $sptm[0][0] = '';
		if (!isset($spws[0][0])) $spws[0][0] = '';
		if (!isset($spsp[0][0])) $spsp[0][0] = '';
		if (!isset($spmi[0][0])) $spmi[0][0] = '';
		if (!isset($sppn[0][0])) $sppn[0][0] = '';
		if (!isset($sppd[0][0])) $sppd[0][0] = '';
		if (!isset($spcl[0][0])) $spcl[0][0] = '';
		if (!isset($spmm[0][0])) $spmm[0][0] = '';
		$sign = array($spon[0][0], $spph[0][0], $spst[0][0], $sppc[0][0], $spfe[0][0], $sptr[0][0], $sptm[0][0], $spws[0][0], $spsp[0][0], $spmi[0][0], $sppn[0][0], $sppd[0][0], $spcl[0][0], $spmm[0][0]);
		$orign = array('[spon]'. $orgname . '[/spon]', '[spph]' . $orgphone . '[/spph]', '[spst]' . $proc_params['procstatus'] . '[/spst]', '[sppc]' . $proc_params['procproc'] . '[/sppc]', '[spfe]' . $proc_params['procfee'] . '[/spfe]', '[sptr]' .  $tr . '[/sptr]', '[sptm]' . $trmode . '[/sptm]',  '[spws]' . $proc_params['procwebsite'] . '[/spws]', '[spsp]' . $proc_params['procstop'] . '[/spsp]',  '[spmi]' . $proc_params['procmin'] . '[/spmi]',  '[sppn]' . $proc_params['procname'] . '[/sppn]',  '[sppd]' . $proc_params['procdescr'] . '[/sppd]', '[spcl]' .  $catlist . '[/spcl]', '[spmm]' . $minmode . '[/spmm]');	
		$message = str_replace($sign, $orign, $body);
		
		$request = $smcFunc['db_query']('', '
				UPDATE {db_prefix}messages
				SET subject = {string:su}, body = {string:bo}
				WHERE id_msg = {int:ms}',
			array(
				'ms' => $msg_id,
				'su' => $subject . '. ' . $txt['spmod_buyoutnumber'] . $buyout_number,
				'bo' => $message,
			)	
		);		
	   return $topic_id;
	}
	else
	{
		$msgOptions = array(
		  'subject' => $subject . '. ' . $txt['spmod_buyoutnumber'] . $buyout_number,
		  'body' => $message,
		  'approved' => !$modSettings['spmod_premoderate'],
		);
		$topicOptions = array(
		  'board' => $proc_params['proc_forum_category'], 
		);	   
		if ($user_info['is_guest']) fatal_error($txt['spmod_notpermissions']);
		else
		{
		  $posterOptions = array(
			 'id' => $user_info['id'],
		  );
		}		
		if (!createPost($msgOptions, $topicOptions, $posterOptions)) 
			fatal_error($txt['spmod_topiccreationerror']);
		return $topicOptions['id'];
	}
}

//Контроллер зоны закупок
function SPModProcurements()
{
	global $smcFunc, $user_info, $context, $sourcedir, $txt, $scripturl, $boardurl;

    isAllowedTo('view_spmod');

	GetCatsByUserID();
	if (isset($_REQUEST['do']))
	{
		//Если передаётся новая закупка, то создать ее
		if (($_REQUEST['do']=='add')&&(isset($_REQUEST['proc_name'])))
		{					
			$pr = proc_param_check();
			$smcFunc['db_insert']('ignore',
				'{db_prefix}spmod_proc',
				array(
					'name' => 'string-255', 
					'description' => 'string-255', 
					'startdate' => 'int', 
					'stopdate' => 'int', 
					'status' => 'string-255', 
					'orgid' => 'int',
					'orgpercent' => 'int',
					'minsum' => 'float',
					'website' => 'string-255',
					'bankfee' => 'float',
					'tr' => 'float',
					'tr_mode' => 'int',
					'minsum_mode' => 'int',
					'banner' => 'string-255',
					'buyout' => 'int',
				),
				array(
					$_REQUEST['proc_name'], 
					$pr['procdescr'], 
					time(), 
					strtotime($pr['procstop']), 
					$pr['procstatus'], 
					$user_info['id'],
					$pr['procproc'],
					$pr['procmin'],
					$pr['procwebsite'],
					$pr['procfee'],
					$pr['proctr'],					
					$pr['proctrmode'],	
					$pr['procminsummode'],
					$smcFunc['htmlspecialchars']($pr['procbanner'], ENT_QUOTES),
					$pr['procbuyout'],
				),
				array('name')
			);	
			$procid = $smcFunc['db_insert_id']('{db_prefix}spmod_proc', 'procid');
			if (!empty($_REQUEST['groups']))
			foreach($_REQUEST['groups'] as $catid)
				$smcFunc['db_insert']('',
					'{db_prefix}spmod_proccat',
					array(
						'procid' => 'int', 'catid' => 'int',
					),
					array(
						$procid, $catid
					),
					array()
				);

			//Создаем тему
			$ti = CreateOrUpdateProcTopic($pr, $procid, null, $pr['procbuyout']);
			//обновить идентификатор темы
			$request = $smcFunc['db_query']('', '
					UPDATE {db_prefix}spmod_proc 
					SET topicid = {int:to}
					WHERE procid = {int:pr}',
				array(
					'to' => $ti,
					'pr' => $procid,						
				)	
			);				
		}
	}		

	$context['page_title'] = $txt['spmod_procurements'];
	$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));

	$context['linktree'][] = array(
		'url' => $scripturl. '?action=spmod;sa=proc',
		'name' => $context['page_title'],
	);	
	
	$listOptions = array(
		'id' => 'proc_list',
		'items_per_page' => 10,
		'title' => $txt['spmod_purchaselist'],
		'no_items_label' => $txt['spmod_rocempty'],
		'base_href' => $scripturl . '?action=spmod;sa=proc',
		'default_sort_col' => 'name',
		'get_items' => array(
			'function' => 'list_getProcEntries',
		),
		'get_count' => array(
			'function' => 'list_getProcCount',
		),
		'columns' => array(
			'name' => array(
				'header' => array(
					'value' => $txt['spmod_purchname'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl, $txt;
						return \'<b><a href="\' . $scripturl . \'?topic=\' . $entry[\'topicid\'] . \'">\' . $entry[\'procname\'] . \'</a></b><br /><small><strong>\' . $txt[\'spmod_cats\'] . \':</strong> \' . $entry[\'proccatnames\'] . \'</small>\';'
					),
				),
				'sort' => array(
					'default' => 'name',
					'reverse' => 'name DESC',
				),		
			),
			'status' => array(
				'header' => array(
					'value' => $txt['spmod_status'],
					'style' => 'width:10%',					
				),
				'data' => array(
					'db' => 'status',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'status',
					'reverse' => 'status DESC',
				),
			),
			'startdate' => array(
				'header' => array(
					'value' => $txt['spmod_purchaseopen'],
					'style' => 'width:15%',										
				),
				'data' => array(
					'db' => 'startdate',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'startdate',
					'reverse' => 'startdate DESC',
				),
			),			
			'stopdate' => array(
				'header' => array(
					'value' => $txt['spmod_purchasestopdate'],
					'style' => 'width:15%',										
				),
				'data' => array(
					'db' => 'stopdate',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'stopdate',
					'reverse' => 'stopdate DESC',
				),
			),
			'edit' => array(
				'header' => array(
					'value' => $txt['spmod_action'],
					'style' => 'width:200px',
				),
				'data' => array(
					'function' => create_function('$entry', '
						return \'<a href="' . $scripturl . '?action=spmod;sa=editproc;procid=\' . $entry[\'procid\'] . \';sesc=' . $context['session_id'] . '"><img src="' . $boardurl . '/SPMod/images/sp/edit.png" alt="'.$txt['spmod_edit'].'" title="'.$txt['spmod_edit'].'"></a>
						<a href="' . $scripturl . '?action=spmod;sa=stopproc;procid=\' . $entry[\'procid\'] . \';topicid=\' . $entry[\'topicid\'] . \';sesc=' . $context['session_id'] . '"><img src="' . $boardurl . '/SPMod/images/sp/stop.png" alt="'.$txt['spmod_purchstat_stop'].'" title="'.$txt['spmod_purchstat_stop'].'"></a>
						<a href="' . $scripturl . '?action=spmod;sa=payproc;procid=\' . $entry[\'procid\'] . \';proc_name=\' . $entry[\'procname\'] . \';topicid=\' . $entry[\'topicid\'] . \';sesc=' . $context['session_id'] . '"><img src="' . $boardurl . '/SPMod/images/sp/creditcard.png" alt="'.$txt['spmod_purchstat_pay'].'" title="'.$txt['spmod_purchstat_pay'].'"></a>						
						<a href="' . $scripturl . '?action=spmod;sa=closeproc;procid=\' . $entry[\'procid\'] . \';topicid=\' . $entry[\'topicid\'] . \';sesc=' . $context['session_id'] . '"><img src="' . $boardurl . '/SPMod/images/sp/closed.png" alt="'.$txt['spmod_purchstat_doclose'].'" title="'.$txt['spmod_purchstat_doclose'].'"></a>
						<a href="' . $scripturl . '?action=spmod;sa=reportproc;procid=\' . $entry[\'procid\'] . \';procname=\' . $entry[\'procname\'] . \' "><img src="' . $boardurl . '/SPMod/images/sp/money.png" alt="'.$txt['spmod_report'].'" title="'.$txt['spmod_report'].'"></a>\';'
					),	
				),
			),
		),	
	);
	
	$CloseListOptions = array(
		'id' => 'closed_proc_list',
		'items_per_page' => 5,
		'title' => $txt['spmod_closedpurchaselist'],
		'no_items_label' => $txt['spmod_rocempty'],
		'base_href' => $scripturl . '?action=spmod;sa=proc',
		'default_sort_col' => 'name',
		'get_items' => array(
			'function' => 'list_getClosedProcEntries',
		),
		'get_count' => array(
			'function' => 'list_getClosedProcCount',
		),
		'columns' => array(
			'name' => array(
				'header' => array(
					'value' => $txt['spmod_purchname'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl, $txt;
						return \'<b><a href="\' . $scripturl . \'?topic=\' . $entry[\'topicid\'] . \'">\' . $entry[\'procname\'] . \'</a></b><br /><small><strong>\' . $txt[\'spmod_cats\'] . \':</strong> \' . $entry[\'proccatnames\'] . \'</small>\';'
					),
				),
				'sort' => array(
					'default' => 'name',
					'reverse' => 'name DESC',
				),				
			),
			'status' => array(
				'header' => array(
					'value' => $txt['spmod_status'],
					'style' => 'width:10%',					
				),
				'data' => array(
					'db' => 'status',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'status',
					'reverse' => 'status DESC',
				),
			),
			'startdate' => array(
				'header' => array(
					'value' => $txt['spmod_purchaseopen'],
					'style' => 'width:15%',										
				),
				'data' => array(
					'db' => 'startdate',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'startdate',
					'reverse' => 'startdate DESC',
				),
			),			
			'stopdate' => array(
				'header' => array(
					'value' => $txt['spmod_purchasestopdate'],
					'style' => 'width:15%',										
				),
				'data' => array(
					'db' => 'stopdate',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'stopdate',
					'reverse' => 'stopdate DESC',
				),
			),
			'edit' => array(
				'header' => array(
					'value' => $txt['spmod_action'],
					'style' => 'width:200px',
				),
				'data' => array(
					'function' => create_function('$entry', '
						return \'<a href="' . $scripturl . '?action=spmod;sa=editproc;procid=\' . $entry[\'procid\'] . \';sesc=' . $context['session_id'] . '"><img src="' . $boardurl . '/SPMod/images/sp/edit.png" alt="'.$txt['spmod_edit'].'" title="'.$txt['spmod_edit'].'"></a>
						<a href="' . $scripturl . '?action=spmod;sa=reportproc;procid=\' . $entry[\'procid\'] . \';procname=\' . $entry[\'procname\'] . \' "><img src="' . $boardurl . '/SPMod/images/sp/money.png" alt="'.$txt['spmod_report'].'" title="'.$txt['spmod_report'].'"></a>\';'
					),	
				),
			),			
		),	
	);
	
	require_once($sourcedir . '/Subs-List.php');
	//Активные закупки
	createList($listOptions);
	//Завершенные в отдельном нижнем окне
	createList($CloseListOptions);
	
	SetAdminProcSettings();
}

function ProcTotalUpdate($pid, $minmode)
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '			
			SELECT 
			SUM(i.price) as totalsum, COUNT(i.price) as totalcount
			FROM {db_prefix}spmod_purchHis as p1
			LEFT JOIN {db_prefix}spmod_item as i on i.itemid = p1.itemid
			WHERE p1.procid = {int:pr}',
		array(
			'pr' => (int)$pid,
			)
	);				
	$row = $smcFunc['db_fetch_row']($request);

	//$minmode - режим "минималки": 1 - минимальная сумма, 2 - минимальное количество
	if (!isset($minmode)) $minmode = 1;
	if ($minmode == 2)
	{	
		if (!isset($row[1])) $row[1] = 0;
		$smcFunc['db_free_result']($request);	

		$smcFunc['db_query']('', '			
				UPDATE {db_prefix}spmod_proc				
				SET cursum = ' . $row[1] . '				 
				WHERE procid = {int:pr}',
			array(
				'pr' => (int)$pid
			)	
		);
	} else
	{
		if (!isset($row[0])) $row[0] = 0;
		$smcFunc['db_free_result']($request);	

		$smcFunc['db_query']('', '			
				UPDATE {db_prefix}spmod_proc				
				SET cursum = ' . $row[0] . '				 
				WHERE procid = {int:pr}',
			array(
				'pr' => (int)$pid
			)	
		);
	}
}

//--ПЕРСОНАЛЬНО ИЗМЕНИТЬ ОРГ ПРОЦЕНТ--
function SPModChangeOrgPerc()
{
	global $smcFunc, $user_info;
	
 	isAllowedTo('view_spmod');
	checkSession();
	if (!isset($_REQUEST['procid'])) fatal_error($txt['spmod_nopurch']);
	if (!isset($_REQUEST['userid'])) fatal_error($txt['spmod_nouserid']);
	if (!isset($_REQUEST['neworg'])) fatal_error($txt['spmod_noneworg']	);
	$smcFunc['db_query']('','
		UPDATE {db_prefix}spmod_purchHis
		SET orgpercent = {int:or} 
		WHERE procid = {int:pr} AND userid = {int:us}',
			array(
				'or' => (int)$_REQUEST['neworg'],
				'pr' => (int)$_REQUEST['procid'],					
				'us' => (int)$_REQUEST['userid'],
			)	
	);
	redirectexit($_SERVER["HTTP_REFERER"]);
}

//--ПЕРСОНАЛЬНО ИЗМЕНИТЬ ТР--
function SPModChangeTR()
{
	global $smcFunc, $user_info, $txt;
	
 	isAllowedTo('view_spmod');
	checkSession();
	if (!isset($_REQUEST['procid'])) fatal_error($txt['spmod_nopurch']);
	if (!isset($_REQUEST['userid'])) fatal_error($txt['spmod_nouserid']);
	if (!isset($_REQUEST['trvalue'])) fatal_error($txt['spmod_nomanualtr']	);
	$smcFunc['db_query']('','
		UPDATE {db_prefix}spmod_purchHis
		SET tr = {int:tr} 
		WHERE procid = {int:pr} AND userid = {int:us}',
			array(
				'tr' => (int)$_REQUEST['trvalue'],
				'pr' => (int)$_REQUEST['procid'],					
				'us' => (int)$_REQUEST['userid'],
			)	
	);
	redirectexit($_SERVER["HTTP_REFERER"]);
}

//-- ОПЛАТИТЬ --
function SPModPayment()
{
	global $smcFunc, $user_info, $sourcedir, $scripturl, $txt;
	
 	isAllowedTo(array('view_spbuy', 'view_spmod'));
	checkSession();
	if (!isset($_REQUEST['procid'])) fatal_error($txt['spmod_nopurch']);
	if (!isset($_REQUEST['userid'])) fatal_error($txt['spmod_nouserid']);	
	if (!isset($_REQUEST['payvalue'])) $_REQUEST['payvalue'] = 0;		

	$request = $smcFunc['db_query']('', '			
			SELECT orgid, name, topicid, email_address
			FROM {db_prefix}spmod_proc
			LEFT JOIN {db_prefix}members ON id_member = orgid
			WHERE procid = {int:pr}
			LIMIT 1',
		array(
			'pr' => (int)$_REQUEST['procid'],
		)	
	);	
	if ($smcFunc['db_num_rows']($request) == 0) fatal_error($txt['spmod_targetprocnotfound']);	
	$procinfo = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);		
	
	$request = $smcFunc['db_query']('', '			
			SELECT id
			FROM {db_prefix}spmod_userproc			
			WHERE userid = {int:ui} and procid = {int:pr}
			LIMIT 1',
		array(
			'pr' => (int)$_REQUEST['procid'],
			'ui' => (int)$_REQUEST['userid'],
		)	
	);
	if ($smcFunc['db_num_rows']($request) == 0)
	{
		$smcFunc['db_insert']('insert',
			'{db_prefix}spmod_userproc',
			array(
				'payment' => 'float', 'userid' => 'int', 'procid' => 'int', 'paymentdate' => 'int'
			),
			array(
				floatval(str_replace(',', '.', $_REQUEST['payvalue'])), (int)$_REQUEST['userid'], (int)$_REQUEST['procid'], time()
			),
			array('userid', 'procid')
		);
	} else
	{
		$row = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_query']('','
			UPDATE {db_prefix}spmod_userproc
			SET payment = {float:pa}, paymentdate = ' . time() . ' 
			WHERE id = {int:id}',
				array(
					'pa' => floatval(str_replace(',', '.', $_REQUEST['payvalue'])),
					'id' => $row[0],					
				)	
		);
	}
	$smcFunc['db_free_result']($request);
	require_once($sourcedir . '/Subs-Post.php');
	
	sendmail(array($procinfo[3]), $txt['spmod_paymentmessagesubject'], str_replace(array('{user}', '{procname}', '{procurl}'), array($user_info['name'], $procinfo[1], $scripturl . '?topic=' . $procinfo[2]), $txt['spmod_paymentmessagebody']), null, null, true);
	
	redirectexit($_SERVER["HTTP_REFERER"]);
}

//Функция добавляет или обновляет таблицу рядов
function PushToLine($lc, $procid, $goodid, $cc, $pa1)
{
	global $smcFunc; 
	
	if ($lc != 0)
	{
		//Сделать запрос и получить текущее количество в ряде и все значения размеров	
		$linerequest = $smcFunc['db_query']('', '			
				SELECT i.params, i.linecount
				FROM {db_prefix}spmod_item as i
				WHERE i.itemid = {int:it}
				LIMIT 1',
			array(
				'it' => (int)$goodid,
			)	
		);
		$row = $smcFunc['db_fetch_row']($linerequest);
		$smcFunc['db_free_result']($linerequest);
		if (isset($row[0])) 
		{
			$allparam = $row[0]; 
			$avail = explode(",", $allparam);	
			if(($key = array_search($pa1, $avail)) !== false)
				 unset($avail[$key]);
			$paramavail = implode(",", $avail);
		} else $paramavail = '';	
		$request = $smcFunc['db_query']('', '			
				SELECT 
				p1.lineid,
				GROUP_CONCAT(p1.param) as unavailparams,
				l.linecurrent
				FROM {db_prefix}spmod_purchHis as p1
				RIGHT JOIN {db_prefix}spmod_purchLines as l on (p1.lineid = l.id) AND (l.linecount > l.linecurrent) AND ((l.paramavail = \'\') OR (FIND_IN_SET({string:pa}, l.paramavail) != 0))
				WHERE p1.procid = {int:pr} AND p1.itemid = {int:it}
				GROUP BY p1.lineid
				LIMIT 1',
			array(
				'pr' => (int)$procid,
				'it' => (int)$goodid,
				'pa' => $pa1,
			)	
		);	
		$cnt = $smcFunc['db_num_rows']($request);
		if ($cnt == 0)
		{
			//Нужно открывать новый ряд
			$smcFunc['db_insert']('',
				'{db_prefix}spmod_purchLines',
				array(
					'linecount' => 'int', 'linecurrent' => 'int', 'paramavail' => 'string-255'
				),
				array(
					$lc, $cc, $paramavail 
				),
				array()
			);
			$lineid = $smcFunc['db_insert_id']('{db_prefix}spmod_purchLines', 'id');
		}
		else
		{
			//ряд уже открыт, обновляем его
			$lines = $smcFunc['db_fetch_row']($request); 
			$lineid = $lines[0];
			$avail = array_diff($avail, explode(",", $lines[1]));
			$paramavail = implode(",", $avail);			
		
			$smcFunc['db_query']('','
				UPDATE {db_prefix}spmod_purchLines
				SET 
				linecurrent = {int:lc},
				paramavail = {string:pa}
				WHERE id = {int:pi}',
					array(
						'pi' => $lineid,
						'lc' => $lines[2] + $cc,
						'pa' => $paramavail
					)	
			);								
		}
		$smcFunc['db_free_result']($request);
	} else $lineid = -1; 	
	return $lineid;
}

//Функция обновляет таблицу рядов при удалении позиций
function RemoveFromLine($lc, $procid, $goodid, $purchid, $purchparam = '')
{
	global $smcFunc; 
	
	if ($lc != 0)
	{	
		$request = $smcFunc['db_query']('', '			
				SELECT p.lineid, linecurrent
				FROM {db_prefix}spmod_purchHis as p
				RIGHT JOIN {db_prefix}spmod_purchLines as l on p.lineid = l.id
				WHERE p.id = {int:id} 
				LIMIT 1',
			array(
				'id' => (int)$purchid,
			)	
		);		
		$cnt = $smcFunc['db_num_rows']($request);
		if ($cnt !=0)
		{
			$row = $smcFunc['db_fetch_row']($request);
			//Совсем удаляем ряд, если оставалась только одна позиция
			if ($row[1] == 1)
			{
				$request = $smcFunc['db_query']('', '			
						DELETE 
						FROM {db_prefix}spmod_purchLines
						WHERE id = {int:id}
						',
					array(
						'id' => (int)$row[0],
					)	
				);				
			} 
			else
			{
				$smcFunc['db_query']('','
					UPDATE {db_prefix}spmod_purchLines
					SET 
					linecurrent = {int:lc},
					paramavail = CONCAT(paramavail, ",", {string:pp})
					WHERE id = {int:id}',
						array(
							'id' => (int)$row[0],
							'lc' => $row[1] - 1,
							'pp' => $purchparam,
						)	
				);				
			}
		}			
		$smcFunc['db_free_result']($request);
	}	
}

//Функция обновляет таблицу рядов при удалении всего заказа
function DeleteFromLine($lc, $procid, $goodid, $userid)
{
	global $smcFunc; 
	
	if ($lc != 0)
	{	
		$request = $smcFunc['db_query']('', '			
				SELECT id, param
				FROM {db_prefix}spmod_purchHis 
				WHERE procid = {int:pi} AND itemid = {int:ii} AND userid = {int:ui}
				',
			array(
				'pi' => (int)$procid,
				'ii' => (int)$goodid,
				'ui' => (int)$userid,
			)	
		);			
		while ($row = $smcFunc['db_fetch_row']($request))
		{
			if (!isset($row[1])) $row[1] = '';
			RemoveFromLine($lc, $procid, $goodid, $row[0], $row[1]);
		}
		$smcFunc['db_free_result']($request);	
	}	
}

//--КУПИТЬ!-- buy
function SPModBuy()
{	
	global $context, $smcFunc, $txt, $user_info, $scripturl, $sourcedir; 

	isAllowedTo('view_spbuy');
	checkSession('get');
	if (isset($_REQUEST['procid'])&&isset($_REQUEST['goodid']))
	{
		if ($context['user']['is_logged'])
		{		
			$request = $smcFunc['db_query']('', '			
					SELECT status, topicid, name, email_address, minsum_mode
					FROM {db_prefix}spmod_proc				
					LEFT JOIN {db_prefix}members ON id_member = orgid
					WHERE procid = {int:pr}
					LIMIT 1',
				array(
					'pr' => (int)$_REQUEST['procid']
				)	
			);
			$row = $smcFunc['db_fetch_row']($request);
			$smcFunc['db_free_result']($request);	
			if (strcasecmp($row[0], $txt['spmod_purchaseopen']) == 0 || strcasecmp($row[0], $txt['spmod_purchstat_overorder']) == 0)
			{
				if (!isset($_REQUEST['buy_count'])) $_REQUEST['buy_count'] = 1;
				$params = '';
				if (isset($_REQUEST['pid1'])) $params = $_REQUEST['pid1'];
					else $_REQUEST['pid1'] = '';
				if (isset($_REQUEST['pid2'])) $params = $params . ', ' . $_REQUEST['pid2'];
					else $_REQUEST['pid2'] = '';
				if (!isset($_REQUEST['param'])) $_REQUEST['param'] = '';
				if (!isset($_REQUEST['lc']) || $_REQUEST['lc'] == '') $lc = 0;
					else $lc = (int)$_REQUEST['lc'];
				if (!isset($_REQUEST['start'])) $_REQUEST['start'] = 0;	

				//поле status в таблице spmod_purchHis
				//НО status сейчас не используется! См. статус в таблице позиций. Возможно удалю это поле в дальнейшем
				//0 - есть в наличии и ряд собран (по умолчанию)
				//1 - нет в наличии (отмечает организатор)
				//2 - ряд еще не собран
				
				$i = 0;
				for ($i = 1; $i <= $_REQUEST['buy_count']; $i++) 
				{
					//Если это ряд, то проверим открыт ли он
					$lineid = PushToLine($lc, $_REQUEST['procid'], $_REQUEST['goodid'], 1, $_REQUEST['pid1']);					
					$smcFunc['db_insert']('',
						'{db_prefix}spmod_purchHis',
						array(
							'itemid' => 'int', 'userid' => 'int', 'procid' => 'int', 'param' => 'string-255', 'lineid' => 'int'
						),
						array(
							$_REQUEST['goodid'], $user_info['id'], $_REQUEST['procid'], $params, $lineid
						),
						array()
					);			
				}
				
				ProcTotalUpdate($_REQUEST['procid'], $row[4]);
				//Отправить уведомление организатору на почту
				require_once($sourcedir . '/Subs-Post.php');
				sendmail(array($row[3]), $txt['spmod_newordersubj'], $txt['spmod_userspace'] . $user_info['name'] . $txt['spmod_spacemakesorderinproc'] . ' <a href="'. $scripturl . '?topic=' . $row[1] . '">' . $row[2] . '</a> ', null, null, true);
				clean_cache();
				if (!isset($_REQUEST['catname'])) $_REQUEST['catname'] = '';
				if (isset($_REQUEST['catid']))
				{		
					$msg = $txt['spmod_successmsg'] . '<a href="' . $scripturl . '?topic=' . $row[1] . '">' . $txt['spmod_proctopic'] . '</a>.';
					redirectexit($scripturl.'?action=spmod;sa=buys;procid='.$_REQUEST['procid'].';catid='.$_REQUEST['catid'].';catname='.$_REQUEST['catname'].';msg=' . rawurlencode($msg) . ';start=' . $_REQUEST['start']);
				} else redirectexit($_SERVER['HTTP_REFERER']);			
			} else fatal_error($txt['spmod_procisclosed']);
		} else fatal_error($txt['spmod_youcannotbuy']);
	}
}

function addAndBuy($uid, $uname)
{
	global $smcFunc, $txt, $scripturl, $sourcedir; 

	checkSession('get');
		
	//Сначала добавляем товар
	$pr = CheckGoodParams();
	$goodid = ItemToDB(-1, $_REQUEST['good_name'], $pr['itemdescr'], $pr['itemimg'], $pr['itemprice'], $pr['itemlink'], $pr['itemarticul']);
	
	if (isset($_REQUEST['procid']))
	{				
		$request = $smcFunc['db_query']('', '			
				SELECT status, topicid, name, email_address, minsum_mode
				FROM {db_prefix}spmod_proc				
				LEFT JOIN {db_prefix}members ON id_member = orgid
				WHERE procid = {int:pr}
				LIMIT 1',
			array(
				'pr' => (int)$_REQUEST['procid']
			)	
		);
		$row = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);	
		if (strcasecmp($row[0], $txt['spmod_purchaseopen']) == 0 || strcasecmp($row[0], $txt['spmod_purchstat_overorder']) == 0)
		{
			if (!isset($_REQUEST['buy_count'])) $_REQUEST['buy_count'] = 1;
			$params = '';
			if (isset($_REQUEST['pid1'])) $params = $_REQUEST['p1capt'] . ': ' . $_REQUEST['pid1'];
			if (!isset($_REQUEST['param'])) $_REQUEST['param'] = '';

			$i=0;
			for ($i = 1; $i <= $_REQUEST['buy_count']; $i++) 
			{				
				$smcFunc['db_insert']('',
					'{db_prefix}spmod_purchHis',
					array(
						'itemid' => 'int', 'userid' => 'int', 'procid' => 'int', 'param' => 'string-255', 'lineid' => 'int'
					),
					array(
						(int)$goodid, (int)$uid, (int)$_REQUEST['procid'], $params, -1
					),
					array()
				);			
			}
			ProcTotalUpdate($_REQUEST['procid'], $row[4]);
			//Отправить уведомление организатору на почту
			require_once($sourcedir . '/Subs-Post.php');
			sendmail(array($row[3]), $txt['spmod_newordersubj'], $txt['spmod_userspace'] . $uname . $txt['spmod_spacemakesorderinproc'] . ' <a href="'. $scripturl . '?topic=' . $row[1] . '">' . $row[2] . '</a> ', null, null, true);
			clean_cache();
			//redirectexit($_SERVER['HTTP_REFERER']);						
		} else fatal_error($txt['spmod_procisclosed']);
	}
}

function SPModAddAndBuy()
{	
	global $user_info, $context; 

	isAllowedTo('view_spbuy');
	if ($context['user']['is_logged'])	
		addAndBuy($user_info['id'], $user_info['name']);
	else fatal_error($txt['spmod_youcannotbuy']);			
}

//--ОТКАЗАТЬСЯ--
function SPModUnBuy()
{	
	global $context, $smcFunc, $txt, $user_info, $sourcedir, $scripturl; 
	
	isAllowedTo('view_spbuy');	
	checkSession('get');	
	
	if (isset($_REQUEST['procid'])&&isset($_REQUEST['goodid']))
	{
		if ($context['user']['is_logged'])
		{
			$request = $smcFunc['db_query']('', '			
					SELECT status, topicid, name, email_address, minsum_mode
					FROM {db_prefix}spmod_proc				
					LEFT JOIN {db_prefix}members ON id_member = orgid
					WHERE procid = {int:pr}
					LIMIT 1',
				array(
					'pr' => $_REQUEST['procid']
				)	
			);
			$row = $smcFunc['db_fetch_row']($request);
			$smcFunc['db_free_result']($request);	
			if (strcasecmp($row[0], $txt['spmod_purchaseopen']) == 0 || strcasecmp($row[0], $txt['spmod_purchstat_overorder']) == 0)
			{
				//Обработать ряд, если это ряд
				if (!isset($_REQUEST['lc']) || $_REQUEST['lc'] == '') $lc = 0;
					else $lc = (int)$_REQUEST['lc'];				
				DeleteFromLine($lc, $_REQUEST['procid'], $_REQUEST['goodid'], $user_info['id']);					
				$smcFunc['db_query']('', '
						DELETE 
						FROM {db_prefix}spmod_purchHis
						WHERE procid = {int:pr} AND itemid = {int:go} AND userid = {int:us} AND status = {int:st}',
					array(
						'pr' => $_REQUEST['procid'],
						'go' => $_REQUEST['goodid'],
						'us' => $user_info['id'],
						'st' => STATUS_OPEN,
					)						
				);
				ProcTotalUpdate($_REQUEST['procid'], $row[4]);				
				require_once($sourcedir . '/Subs-Post.php');
				sendmail(array($row[3]), $txt['spmod_delordersubj'], $txt['spmod_userspace'] . $user_info['name'] . $txt['spmod_spacedelsorderinproc'] . ' <a href="'. $scripturl . '?topic=' . $row[1] . '">' . $row[2] . '</a> ', null, null, true);
				clean_cache();
				redirectexit($_SERVER['HTTP_REFERER']);	
			} else fatal_error($txt['spmod_procisclosed']);
		}
	}
	else fatal_error($txt['spmod_noitemid']);
}

//--ОТКАЗАТЬСЯ ОТ ОДНОЙ ПОЗИЦИИ--
function SPModOneUnBuy()
{	
	global $context, $smcFunc, $txt, $user_info, $sourcedir, $scripturl; 
	
	isAllowedTo('view_spbuy');	
	checkSession('get');	
	
	if (isset($_REQUEST['procid']) && isset($_REQUEST['goodid']))
	{
		if ($context['user']['is_logged'])
		{
			$request = $smcFunc['db_query']('', '			
					SELECT status, topicid, name, email_address, minsum_mode
					FROM {db_prefix}spmod_proc				
					LEFT JOIN {db_prefix}members ON id_member = orgid
					WHERE procid = {int:pr}
					LIMIT 1',
				array(
					'pr' => $_REQUEST['procid']
				)	
			);
			$row = $smcFunc['db_fetch_row']($request);
			$smcFunc['db_free_result']($request);	
			if (strcasecmp($row[0], $txt['spmod_purchaseopen']) == 0 || strcasecmp($row[0], $txt['spmod_purchstat_overorder']) == 0)
			{
				$request = $smcFunc['db_query']('', '			
						SELECT id, param
						FROM {db_prefix}spmod_purchHis
						WHERE procid = {int:pr} AND itemid = {int:go} AND userid = {int:us}
						LIMIT 1',
					array(
						'pr' => $_REQUEST['procid'],
						'go' => $_REQUEST['goodid'],
						'us' => $user_info['id'],
					)	
				);
				$purchid = $smcFunc['db_fetch_row']($request);
				$smcFunc['db_free_result']($request);	
				if (isset($purchid))
				{
					//Обработать ряд, если это ряд
					if (!isset($_REQUEST['lc']) || $_REQUEST['lc'] == '') $lc = 0;
						else $lc = (int)$_REQUEST['lc'];				
					if (!isset($purchid[1])) $purchid[1] = '';	
					RemoveFromLine($lc, $_REQUEST['procid'], $_REQUEST['goodid'], $purchid[0], $purchid[1]);	
					$smcFunc['db_query']('', '
							DELETE 
							FROM {db_prefix}spmod_purchHis
							WHERE id = {int:id} AND status = {int:st}',
						array(
							'id' => $purchid[0],
							'st' => STATUS_OPEN,
						)						
					);		
					ProcTotalUpdate($_REQUEST['procid'], $row[4]);				
					require_once($sourcedir . '/Subs-Post.php');
					sendmail(array($row[3]), $txt['spmod_delordersubj'], $txt['spmod_userspace'] . $user_info['name'] . $txt['spmod_spacedelsorderinproc'] . ' <a href="'. $scripturl . '?topic=' . $row[1] . '">' . $row[2] . '</a> ', null, null, true);
					clean_cache();
					redirectexit($_SERVER['HTTP_REFERER']);	
					
				} else fatal_error($txt['spmod_noitemid']);
			} else fatal_error($txt['spmod_procisclosed']);
		}
	}
	else fatal_error($txt['spmod_noitemid']);
}

//--НЕТ В НАЛИЧИИ--
function SPModNo()
{	
	global $context, $smcFunc, $txt, $user_info; 
	
 	isAllowedTo('view_spmod');
	checkSession('get');
	if (isset($_REQUEST['procid'])&&isset($_REQUEST['goodid'])&&isset($_REQUEST['userid']))
	{
		$request = $smcFunc['db_query']('', '			
				SELECT orgid, status, minsum_mode
				FROM {db_prefix}spmod_proc				
				WHERE procid = {int:pr}
				LIMIT 1',
			array(
				'pr' => $_REQUEST['procid']
			)	
		);
		$row = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);	
		if (strcasecmp($row[1], $txt['spmod_purchstat_open']) == 0 || strcasecmp($row[1], $txt['spmod_purchstat_stop']) == 0 || strcasecmp($row[1], $txt['spmod_purchstat_overorder']) == 0 || strcasecmp($row[1], $txt['spmod_purchstat_stopoverorder']) == 0)
		{
			if ($row[0] == $user_info['id'] || $_REQUEST['userid'] == $user_info['id'])
			{
				if ($context['user']['is_logged'])
				{
					// 1 - нет в наличии					
					$smcFunc['db_query']('','
						UPDATE {db_prefix}spmod_item
						SET status = 1 
						WHERE itemid = {int:go}',
							array(
								'go' => $_REQUEST['goodid'],
							)	
					);					
					ProcTotalUpdate($_REQUEST['procid'], $row[2]);	
					clean_cache();					
					redirectexit($_SERVER["HTTP_REFERER"]);
				}
			} else fatal_error($txt['spmod_delerror']);
		} else fatal_error($txt['spmod_procisclosed']);
	} else fatal_error($txt['spmod_noitemid']);
}

//--ЕСТЬ В НАЛИЧИИ--
function SPModYes()
{	
	global $context, $smcFunc, $txt, $user_info; 
	
 	isAllowedTo('view_spmod');
	checkSession('get');
	if (isset($_REQUEST['procid'])&&isset($_REQUEST['goodid'])&&isset($_REQUEST['userid']))
	{
		$request = $smcFunc['db_query']('', '			
				SELECT orgid, status, minsum_mode
				FROM {db_prefix}spmod_proc				
				WHERE procid = {int:pr}
				LIMIT 1',
			array(
				'pr' => $_REQUEST['procid']
			)	
		);
		$row = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);	
		if (strcasecmp($row[1], $txt['spmod_purchstat_open']) == 0 || strcasecmp($row[1], $txt['spmod_purchstat_stop']) == 0 || strcasecmp($row[1], $txt['spmod_purchstat_overorder']) == 0 || strcasecmp($row[1], $txt['spmod_purchstat_stopoverorder']) == 0)
		{
			if ($row[0] == $user_info['id'] || $_REQUEST['userid'] == $user_info['id'])
			{
				if ($context['user']['is_logged'])
				{
					//0 - есть
					$smcFunc['db_query']('','
						UPDATE {db_prefix}spmod_item
						SET status = 0 
						WHERE itemid = {int:go}',
							array(
								'go' => $_REQUEST['goodid'],
							)	
					);					
					ProcTotalUpdate($_REQUEST['procid'], $row[2]);	
					clean_cache();					
					redirectexit($_SERVER["HTTP_REFERER"]);
				}
			} else fatal_error($txt['spmod_delerror']);
		} else fatal_error($txt['spmod_procisclosed']);
	} else fatal_error($txt['spmod_noitemid']);
}

//--УДАЛИТЬ ЗАКАЗ-- удаляет сам орг чужой заказ
function SPModOrdDel()
{	
	global $context, $smcFunc, $txt, $user_info, $sourcedir; 
	
 	isAllowedTo('view_spmod');
	checkSession('get');
	
	if (isset($_REQUEST['procid']) && isset($_REQUEST['goodid']) && isset($_REQUEST['userid']))
	{
		$request = $smcFunc['db_query']('', '			
				SELECT status, topicid, name, email_address, orgid, minsum_mode
				FROM {db_prefix}spmod_proc				
				LEFT JOIN {db_prefix}members ON id_member = orgid
				WHERE procid = {int:pr}
				LIMIT 1',							
			array(
				'pr' => $_REQUEST['procid']
			)	
		);
		$row = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);	
		if (strcasecmp($row[0], $txt['spmod_purchaseopen']) == 0)
		{
			if ($row[4] == $user_info['id'] || $_REQUEST['userid'] == $user_info['id'])
			{
				if ($context['user']['is_logged'])
				{
					//Обработать ряд, если это ряд
					if (!isset($_REQUEST['lc']) || $_REQUEST['lc'] == '') $lc = 0;
						else $lc = (int)$_REQUEST['lc'];		
					DeleteFromLine($lc, $_REQUEST['procid'], $_REQUEST['goodid'],$_REQUEST['userid']);					
					$smcFunc['db_query']('', '
							DELETE 
							FROM {db_prefix}spmod_purchHis
							WHERE procid = {int:pr} AND itemid = {int:go} AND userid = {int:us}',
						array(
							'pr' => $_REQUEST['procid'],
							'go' => $_REQUEST['goodid'],
							'us' => $_REQUEST['userid'],
						)						
					);
					ProcTotalUpdate($_REQUEST['procid'], $row[5]);					
					clean_cache();
					redirectexit($_SERVER['HTTP_REFERER']);	
				}
			} else fatal_error($txt['spmod_delerror']);
		} else fatal_error($txt['spmod_procisclosed']);
	} else fatal_error($txt['spmod_noitemid']);
}

//Контроллер зоны редактирования товара
function SPModEditGood()
{
	global $context, $smcFunc, $scripturl, $txt; 

	isAllowedTo('view_spmod');	
	
	if (isset($_REQUEST['goodid']))
	{	
		if (isset($_REQUEST['do']))
		{
			if ($_REQUEST['do'] == 'save')
			{				
				$pr = CheckGoodParams();
				//Запросить текущий каталог (Теперь каталог товара можно менять)
				if (isset($_REQUEST['catid'])) $context['spmod_curcat'] = $_REQUEST['catid'];
				else
				{
					$request = $smcFunc['db_query']('', '
						SELECT catid
						FROM {db_prefix}spmod_item
						WHERE itemid = {int:it}
						LIMIT 1',
					array(
							'it' => $_REQUEST['goodid']
						)
					);		
					$row = $smcFunc['db_fetch_row']($request);
					$smcFunc['db_free_result']($request);
					$context['spmod_curcat'] = $row[0];				
				}
				$smcFunc['db_insert']('replace',
					'{db_prefix}spmod_item',
					array(
						'itemid' => 'int', 
						'name' => 'string-255', 
						'description' => 'string-255', 
						'image' => 'string-255', 
						'price' => 'float', 
						'catid' => 'int',
						'link' => 'string-255',
						'articul' => 'string-255',
						'linecount' => 'int',
						'params' => 'string',
						'linecaption' => 'string-255',
					),
					array(
						$_REQUEST['goodid'], 
						$pr['itemname'], 
						$pr['itemdescr'], 
						$pr['itemimg'], 
						$pr['itemprice'], 
						$context['spmod_curcat'],
						$pr['itemlink'],
						$pr['itemarticul'],
						$pr['itemlinecount'],
						$pr['itemparams'],
						$pr['itemlinecaption'],
					),
					array('itemid')
				);
				if (isset($_REQUEST['topicid'])) redirectexit($scripturl . '?topic=' . $_REQUEST['topicid']);
					else redirectexit($scripturl.'?action=spmod;sa=goods;catid='.$context['spmod_curcat']);		
			}
		}
		else
		{		
			$context['page_title'] = $txt['spmod_goods'];
			$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));
		
			$context['linktree'][] = array(
				'url' => $scripturl. '?action=spmod;sa=goods',
				'name' => $context['page_title'],
			);	
	
			$request = $smcFunc['db_query']('', '
				SELECT itemid, name, description, price, image, link, articul, param1, param2, catid, linecount, params, linecaption
				FROM {db_prefix}spmod_item
				WHERE itemid = {int:it}
				LIMIT 1',
			array(
					'it' => $_REQUEST['goodid']
				)
			);		
			$row = $smcFunc['db_fetch_row']($request);			
			$smcFunc['db_free_result']($request);
			$context['spitem_curid'] = $row[0];
			$context['spitem_curname'] = $row[1];
			$context['spitem_curdesr'] = $row[2];
			$context['spitem_curprice'] = $row[3];
			$context['spitem_curimage'] = $row[4];
			$context['spitem_curlink'] = $row[5];
			$context['spitem_curarticul'] = $row[6];
			$context['spitem_curparam1'] = $row[7];
			$context['spitem_curparam2'] = $row[8];
			$context['spmod_curcat'] = $row[9];
			$context['spitem_curlinecount'] = $row[10];
			$context['spitem_curparams'] = $row[11];
			$context['spitem_curlinecaption'] = $row[12];
			if (isset($_REQUEST['topicid'])) $context['spitem_curtopic'] = $_REQUEST['topicid'];
		}
		GetParamsByUserID();
		GetCatsByUserID(); //Чтобы менять принадлежность к каталогам
	} 
	else
		fatal_error($txt['spmod_noitem']);
}

function SendPaymentInfo($topicid, $procname)
{
	global $smcFunc, $sourcedir, $scripturl, $txt, $user_info;
	
	$request = $smcFunc['db_query']('', '
		SELECT DISTINCT m.email_address, m.id_member, m.vk_id, m.real_name
		FROM {db_prefix}spmod_purchHis as p
		LEFT JOIN {db_prefix}members as m on m.id_member = p.userid		
		LEFT JOIN {db_prefix}spmod_orginfo as o on o.orgid = {int:oi}
		WHERE p.procid = {int:pr}
		GROUP BY p.userid',
	array(
		'pr' => (int)$_REQUEST['procid'],
		'oi' => (int)$user_info['id'],
		)
	);					
	$row = $smcFunc['db_fetch_row']($request);			
	$smcFunc['db_free_result']($request);					
	if (isset($row[0]))
	{
		require_once($sourcedir . '/Subs-Post.php');
		sendpm(
			array('to' => array($row[1]), 'bcc' => array()), 
			$txt['spmod_paymessagesubject'], 
			str_replace(
				array('{procname}', '{procurl}'), 
				array($procname, $scripturl . '?topic=' . $topicid . '.new#new'), '[b]' . $row[3] . '[/b], ' . $txt['spmod_paymessagebody']), false);
	}
}
//Контроллер зоны редактирования закупок
function SPModEditProc()
{
	global $context, $smcFunc, $scripturl, $user_info, $txt; 

	isAllowedTo('view_spmod');	
	
	if (isset($_REQUEST['procid']))
	{	
		GetCatsByUserID();
		if (isset($_REQUEST['do']))
		{
			if ($_REQUEST['do'] == 'save')
			{
				//Обновить связь закупки с каталогами	
				$smcFunc['db_query']('', '
						DELETE 
						FROM {db_prefix}spmod_proccat
						WHERE procid = {int:id}',
					array(
						'id' => $_REQUEST['procid'],
					)						
				);							
				if (!empty($_REQUEST['groups']))		
				foreach($_REQUEST['groups'] as $catid)
					$smcFunc['db_insert']('',
						'{db_prefix}spmod_proccat',
						array(
							'procid' => 'int', 'catid' => 'int',
						),
						array(
							$_REQUEST['procid'], $catid
						),
						array()
					);			
				//Обновить закупку					
				$pr = proc_param_check();				
			
				$smcFunc['db_query']('', '
					UPDATE {db_prefix}spmod_proc
					SET 
					name = {string:na},
					description = {string:de},
					stopdate = {int:ti},
					status = {string:st},
					orgid = {int:oi},
					orgpercent = {int:op},
					minsum = {float:mi},
					topicid = {int:to},
					website = {string:we},
					bankfee = {float:ba},
					tr = {float:tr},
					tr_mode = {int:tm},
					minsum_mode = {int:ms},
					banner = {string:bn},
					buyout = {int:bo}
					WHERE procid = {int:id}',
					array(
						'id' => (int)$_REQUEST['procid'],
						'na' => $smcFunc['htmlspecialchars']($_REQUEST['proc_name'], ENT_QUOTES),
						'de' => $smcFunc['htmlspecialchars']($pr['procdescr'], ENT_QUOTES),
						'ti' => strtotime($pr['procstop']),
						'st' => $pr['procstatus'], 
						'oi' => (int)$user_info['id'],
						'op' => (int)$pr['procproc'],
						'mi' => (float)$pr['procmin'],
						'to' => (int)$pr['proctopic'],
						'we' => $pr['procwebsite'],
						'ba' => (float)$pr['procfee'],						
						'tr' => (float)$pr['proctr'],
						'tm' => (int)$pr['proctrmode'],
						'ms' => (int)$pr['procminsummode'],
						'bn' => $smcFunc['htmlspecialchars']($pr['procbanner'], ENT_QUOTES),
						'bo' => (int)$pr['procbuyout'],
					)
				);		
		
				ProcTotalUpdate($_REQUEST['procid'], $pr['procminsummode']);
				//Уведомления УЗ, если статус = оплачиваем
				if (strcasecmp($pr['procstatus'], $txt['spmod_purchstat_pay']) == 0)
				{
					SendPaymentInfo($pr['proctopic'], $_REQUEST['proc_name']);
					PostPaymentTable($pr['proctopic'], $_REQUEST['proc_name']);	
				}
				
				if (strcasecmp($pr['procstatus'], $txt['spmod_purchstat_stop']) == 0 || strcasecmp($pr['procstatus'], $txt['spmod_purchstat_overorder']) == 0)
					ChangeStateOrder(STATUS_STOP);
				if (strcasecmp($pr['procstatus'], $txt['spmod_purchstat_open']) == 0)
					ChangeStateOrder(STATUS_OPEN);				
				//обновить топик
				CreateOrUpdateProcTopic($pr, $_REQUEST['procid'], $pr['proctopic'], $pr['procbuyout']);								
			}
			redirectexit($scripturl.'?action=spmod;sa=proc');	
		}
		else
		{		
			$context['page_title'] = $txt['spmod_procurements'];
			$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));

			$context['linktree'][] = array(
				'url' => $scripturl. '?action=spmod;sa=proc',
				'name' => $context['page_title'],
			);	
	
			$request = $smcFunc['db_query']('', '
					SELECT procid, name, description, stopdate, status, orgpercent, minsum, topicid, id_board, website, bankfee, tr, tr_mode, minsum_mode, banner, buyout
					FROM {db_prefix}spmod_proc
					LEFT JOIN {db_prefix}topics ON topicid = id_topic					
					WHERE procid = {int:pr}
					LIMIT 1',
				array(
					'pr' => $_REQUEST['procid']
				)	
			);		
			$row = $smcFunc['db_fetch_row']($request);			
			$smcFunc['db_free_result']($request);
			$context['spproc_curid'] = $row[0];
			$context['spproc_curname'] = $row[1];
			$context['spproc_curdesr'] = $row[2];
			$context['spproc_curstop'] = $row[3];
			$context['spproc_curstatus'] = $row[4];
			$context['spproc_curpercent'] = $row[5];
			$context['spproc_curmin'] = $row[6];
			$context['spproc_curtopic'] = $row[7];
			$context['spproc_curboard'] = $row[8];
			$context['spproc_curwebsite'] = $row[9];
			$context['spproc_curfee'] = $row[10];
			$context['spproc_curtr'] = $row[11];
			$context['spproc_curtrmode'] = $row[12];
			$context['spproc_curminsummode'] = $row[13];
			$context['spproc_curbanner'] = $row[14];
			$context['spproc_curbuyout'] = $row[15];
			$request = $smcFunc['db_query']('', '
					SELECT catid
					FROM {db_prefix}spmod_proccat
					WHERE procid = {int:pr}',
				array(
					'pr' => $_REQUEST['procid']
				)	
			);	
			while ($row = $smcFunc['db_fetch_row']($request))
				$context['spproc_curcats'][] = $row[0];
			$smcFunc['db_free_result']($request);
			SetAdminProcSettings();
		}
	}
	else
		fatal_error($txt['spmod_noeditedpurchid']);
}

//"В заказ"
function ChangeStateOrder($stateorder)
{
	global $smcFunc;
	
	//Статус = стоп или статус = стоп.дозаказы
	$smcFunc['db_query']('', '
		UPDATE {db_prefix}spmod_purchHis
		SET 
		status = {int:st}
		WHERE procid = {int:id}',
		array(
			'id' => (int)$_REQUEST['procid'],
			'st' => (int)$stateorder,
		)
	);		
}

//Только стоп
function SPModStopProc()
{
	global $smcFunc, $scripturl, $txt; 

	isAllowedTo('view_spmod');	
	checkSession('get');
	if (isset($_REQUEST['procid']))
	{
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}spmod_proc
			SET 
			status = {string:st}
			WHERE procid = {int:id}',
			array(
				'id' => (int)$_REQUEST['procid'],
				'st' => $txt['spmod_purchstat_stop'], 
			)
		);	
		ChangeStateOrder(STATUS_STOP);
		redirectexit($scripturl . '?topic=' . $_REQUEST['topicid']);		
	}
	else
		fatal_error($txt['spmod_noeditedpurchid']);
}

//Только закрыть
function SPModCloseProc()
{
	global $smcFunc, $scripturl, $txt, $modSettings, $sourcedir; 

	isAllowedTo('view_spmod');	
	checkSession('get');
	if (isset($_REQUEST['procid']))
	{		
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}spmod_proc
			SET 
			status = {string:st}
			WHERE procid = {int:id}',
			array(
				'id' => (int)$_REQUEST['procid'],
				'st' => $txt['spmod_purchstat_close'], 
			)
		);
		require_once($sourcedir . '/MoveTopic.php');
		moveTopics(array((int)$_REQUEST['topicid']), $modSettings['spmod_sparchive']);		
		redirectexit($scripturl.'?action=spmod;sa=proc');
	}
	else
		fatal_error($txt['spmod_noeditedpurchid']);
}

//Закрывает администратор СП
function SPModCloseProcByAdmin()
{
	global $smcFunc, $scripturl, $txt, $modSettings, $sourcedir, $user_info; 

	isAllowedTo('view_spadmin');	
	checkSession('get');
	if (isset($_REQUEST['procid']))
	{	
		$request = $smcFunc['db_query']('', '
				SELECT orgid, name, topicid
				FROM {db_prefix}spmod_proc
				WHERE procid = {int:pi}
				LIMIT 1',
			array(
				'pi' => (int)$_REQUEST['procid'],
			)	
		);		
		$row = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);	
		
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}spmod_proc
			SET 
			status = {string:st}
			WHERE procid = {int:id}',
			array(
				'id' => (int)$_REQUEST['procid'],
				'st' => $txt['spmod_purchstat_close'], 
			)
		);
		require_once($sourcedir . '/MoveTopic.php');
		require_once($sourcedir . '/Subs-Post.php');
		moveTopics(array($row[2]), $modSettings['spmod_sparchive']);		
		sendmail(array($row[0]), $txt['spmod_closebyspadminsubject'], str_replace(array('{spadmin}', '{procname}', '{procurl}'), array($user_info['name'], $row[1], $scripturl . '?topic=' . $row[2]), $txt['spmod_closebyspadmin']), null, null, true);			
		redirectexit($_SERVER["HTTP_REFERER"]);
	}
	else
		fatal_error($txt['spmod_noeditedpurchid']);
}

//Закупку удаляет администратор СП
function SPModDelProc()
{
	global $smcFunc, $scripturl, $txt, $modSettings, $sourcedir, $user_info; 

	isAllowedTo('view_spadmin');	
	checkSession();

	if (isset($_REQUEST['procid']))
	{		
		if (!is_array($_REQUEST['procid']))
			$procs = array($_REQUEST['procid']);
		else
			$procs = array_unique($_REQUEST['procid']);			
		foreach ($procs as $k => $v)
			$procs[$k] = (int)$v;
		
		$request = $smcFunc['db_query']('', '
				SELECT orgid, name, topicid
				FROM {db_prefix}spmod_proc
				WHERE procid IN ({array_int:id})',
			array(
				'id' => $procs,
			)	
		);	

		$smcFunc['db_query']('', '
				DELETE 
				FROM {db_prefix}spmod_proc
				WHERE procid IN ({array_int:id})',
			array(
				'id' => $procs,
			)
		);	
		$smcFunc['db_query']('', '
				DELETE 
				FROM {db_prefix}spmod_proccat
				WHERE procid IN ({array_int:id})',
			array(
				'id' => $procs,
			)						
		);
		$smcFunc['db_query']('', '
				DELETE 
				FROM {db_prefix}spmod_purchHis
				WHERE procid IN ({array_int:id})',
			array(
				'id' => $procs,
			)						
		);		
		
		require_once($sourcedir . '/RemoveTopic.php');
		require_once($sourcedir . '/Subs-Post.php');
		
		while ($row = $smcFunc['db_fetch_row']($request))
		{
			$delprocs[] = array(
				'orgid' => $row[0],
				'name' => $row[1],
				'topicid' => $row[2],
			);					
		}		
		$smcFunc['db_free_result']($request);	
				
		foreach ($delprocs as $delproc)
		{
			removeTopics(array($delproc['topicid']));
			sendmail(array($delproc['orgid']), $txt['spmod_deletedbyspadminsubject'], str_replace(array('{spadmin}', '{procname}', '{procurl}'), array($user_info['name'], $delproc['name'], $scripturl . '?topic=' . $delproc['topicid']), $txt['spmod_deletedbyspadmin']), null, null, true);			
		}	
		redirectexit($_SERVER["HTTP_REFERER"]);
	}
	else
		fatal_error($txt['spmod_noeditedpurchid']);
}

function PostPaymentTable($topicid, $topicname)
{
	global $context, $smcFunc, $txt, $user_info, $sourcedir, $scripturl; 
	
	//Опубликовать таблицу с расчетами в теме закупки
	if (isset($topicid))
	{
		//100 - максимальное количество участников
		list_getCustomerEntries(0, 100, 'm.real_name');

		$body = '
		
[table][tr][td][b]' . $txt['spmod_nick'] . '			[/b][/td][td][b]'.$txt['spmod_count'].'		[/b][/td][td][b]'.$txt['spmod_c_summa'].'		[/b][/td][td][b]'.$txt['spmod_orgp'].'		[/b][/td][td][b]'.$txt['spmod_c_bank'].'		[/b][/td][td][b]'.$txt['spmod_c_tr'].'			[/b][/td][td][b]'.$txt['spmod_forpay'].'		[/b][/td][/tr]';
		$i = 0;
		if (!empty($context['report_real_name'])) foreach($context['report_real_name'] as $report_real_name)
		{
			$body = $body . '[tr][td][b]' . $report_real_name . '[/b][/td][td]' . $context['report_cnt'][$i] . '[/td][td]' . $context['report_summ'][$i] . '[/td][td]' . $context['report_org'][$i] . '[/td][td]' . $context['report_bank'][$i] . '[/td][td]' . $context['report_tr'][$i] . '[/td][td][b][color=red]' . $context['report_itogo'][$i] . '[/color][/b][/td]';
			$i++;
		}
		$body = $body . '[/table]';
		
		$msgOptions = array(
			'subject' => $smcFunc['htmlspecialchars']($topicname, ENT_QUOTES),
			'body' => str_replace('{scripturl}', $scripturl, $txt['spmod_paymentmessage']) . $body,
		);
		$topicOptions = array(
			'board' => 0,
			'id' => (int)$topicid, 
		);	   
		if ($user_info['is_guest']) fatal_error($txt['spmod_notpermissions']);
		else
		{
		  $posterOptions = array(
				'id' => $user_info['id'],
				'update_post_count' => false, 
		  );
		}	
		require_once($sourcedir . '/Subs-Post.php');			
		if (!createPost($msgOptions, $topicOptions, $posterOptions)) 
			fatal_error($txt['spmod_topiccreationerror']);
	}	
}

//Изменить состояние только на "оплачиваем" 
function SPModPayProc()
{
	global $smcFunc, $scripturl, $txt, $context; 

	isAllowedTo('view_spmod');	
	checkSession('get');
	if (isset($_REQUEST['procid']))
	{	
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}spmod_proc
			SET 
			status = {string:st}
			WHERE procid = {int:id}',
			array(
				'id' => (int)$_REQUEST['procid'],
				'st' => $txt['spmod_purchstat_pay'], 
			)
		);
		SendPaymentInfo($_REQUEST['topicid'], $_REQUEST['proc_name']);
		PostPaymentTable($_REQUEST['topicid'], $_REQUEST['proc_name']);		
		redirectexit($scripturl . '?topic=' . $_REQUEST['topicid'] . '.new#new');
	}
	else
		fatal_error($txt['spmod_noeditedpurchid']);
}

//Контроллер зоны отчетов по закупкам
function SPModReportProc()
{
	global $context, $smcFunc, $scripturl, $txt, $sourcedir, $modSettings; 
	isAllowedTo('view_spmod');		
	if (!isset($_REQUEST['procname'])) $_REQUEST['procname'] = '';

	$columns = array();
	$columns['name'] = array(
				'header' => array(
					'value' => $txt['spmod_c_name'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl;
						return \'<a href="\' . $scripturl . \'?action=profile;u=\' . $entry[\'userid\'] . \'">\' . $entry[\'real_name\'] . \'</a>\';'
					),	
				),
				'sort' => array(
					'default' => 'm.real_name',
					'reverse' => 'm.real_name DESC',
				),				
			);
	$columns['orgname'] = array(
				'header' => array(
					'value' => $txt['spmod_orgfi'],
				),
				'data' => array(
					'db' => 'orgname',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'orgname',
					'reverse' => 'orgname DESC',
				),
			);
	if ($modSettings['spmod_addaddress'])			
		$columns['orgaddress'] = array(			
						'header' => array(
						'value' => $txt['spmod_orgaddress'],
					),
						'data' => array(
						'db' => 'orgaddress',
						'style' => 'text-align: center;',
					),				
				);	
	$columns['orgphone'] = array(
				'header' => array(
					'value' => $txt['spmod_orgphone'],
				),
				'data' => array(
					'db' => 'orgphone',
					'style' => 'text-align: center;',
				),				
			);	
	$columns['count'] = array(
				'header' => array(
					'value' => $txt['spmod_c_count'],
				),
				'data' => array(
					'db' => 'cnt',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'cnt',
					'reverse' => 'cnt DESC',
				),
			);
	$columns['summa'] = array(
				'header' => array(
					'value' => $txt['spmod_c_summa'],
				),
				'data' => array(
					'db' => 'summ',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'summ',
					'reverse' => 'summ DESC',
				),
			);
	$columns['org'] = array(
				'header' => array(
					'value' => $txt['spmod_c_org'] . ', ' . $txt['spmod_currency'],
				),
				'data' => array(
					'db' => 'org',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'org',
					'reverse' => 'org DESC',
				),
			);					
	$columns['bank'] = array(
				'header' => array(
					'value' => $txt['spmod_c_bank'],
				),
				'data' => array(
					'db' => 'bank',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'bank',
					'reverse' => 'bank DESC',
				),
			);
	$columns['tr'] = array(
				'header' => array(
					'value' => $txt['spmod_c_tr'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl, $txt, $context, $scripturl;
						if ($entry[\'trmode\'] == 5)
							$outstring = \'<form action="\'. $scripturl . \'?action=spmod;sa=changetr" name="manualtr" id="manualtr" method="post" ><input type="text" name="trvalue" size="5" value="\' . $entry[\'tr\'] . \'" ><input type="hidden" name="userid" value="\' . $entry[\'userid\'] . \'" /><input type="hidden" name="procid" value="\' . $_REQUEST[\'procid\'] . \'" /><input type="hidden" name="sc" value="\' . $context[\'session_id\'] . \'" /> <input type="submit" value="\' . $txt[\'spmod_edit\'] . \'" class="button_submit"></form>\';
						else
							$outstring = $entry[\'tr\'];
						return $outstring;'
					),	
				),				
				'sort' => array(
					'default' => 'tr',
					'reverse' => 'tr DESC',
				),
			);
	$columns['itogo'] = array(
				'header' => array(
					'value' => $txt['spmod_c_itogo'],
				),
				'data' => array(
					'db' => 'itogo',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'itogo',
					'reverse' => 'itogo DESC',
				),
			);
	$columns['distribution'] = array(
				'header' => array(
					'value' => $txt['spmod_distrib'],
				),
				'data' => array(
					'db' => 'distribution',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'distribution',
					'reverse' => 'distribution DESC',
				),
			);
	$columns['orgedit'] = array(
				'header' => array(
					'value' => $txt['spmod_c_org'] . ', %',
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl, $txt, $context, $scripturl;
						return \'<form action="\'. $scripturl . \'?action=spmod;sa=changeop" name="orgchange" id="orgchange" method="post" ><input type="text" name="neworg" size="3" value="\' . $entry[\'orgpercent\'] . \'" ><input type="hidden" name="userid" value="\' . $entry[\'userid\'] . \'" /><input type="hidden" name="procid" value="\' . $_REQUEST[\'procid\'] . \'" /><input type="hidden" name="sc" value="\' . $context[\'session_id\'] . \'" /> <input type="submit" value="\'.$txt[\'spmod_edit\'].\'" class="button_submit"></form>\';'
					),	
				),
				'sort' => array(
					'default' => 'org',
					'reverse' => 'org DESC',
				),				
			);
	$columns['payment'] = array(
				'header' => array(
					'value' => $txt['spmod_payment'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl, $txt, $context, $scripturl;
						$outstring = \'<form action="\'. $scripturl . \'?action=spmod;sa=pay" name="payment" id="payment" method="post" ><input type="text" name="payvalue" size="5" value="\' . $entry[\'payment\'] . \'" ><input type="hidden" name="userid" value="\' . $entry[\'userid\'] . \'" /><input type="hidden" name="procid" value="\' . $_REQUEST[\'procid\'] . \'" /><input type="hidden" name="sc" value="\' . $context[\'session_id\'] . \'" /> <input type="submit" value="\' . $txt[\'spmod_paymentcomplite\'] . \'" class="button_submit"></form>\';
						if ($entry[\'paymentdate\'] != 0) 
							$outstring = $outstring . \'<smalltext>\' . $txt[\'spmod_paymentdate\'] . \': <b>\' . date(\'j.m.Y\', $entry[\'paymentdate\']) . \'</b></smalltext>\'; 
						else 
							$outstring = $outstring . \'<smalltext><b>\' . $txt[\'spmod_nopayment\'] . \'</b></smalltext>\';
						return $outstring;'
					),	
				),				
			);					
			
	$listOptions = array(
		'id' => 'report_list',
		'items_per_page' => 50, 
		'title' => $txt['spmod_customers'] . '"' . $_REQUEST['procname'] . '"',
		'no_items_label' => $txt['spmod_nocustomers'],
		'base_href' => $scripturl . '?action=spmod;sa=reportproc',
		'default_sort_col' => 'name',
		'get_items' => array(
			'function' => 'list_getCustomerEntries',
		),
		'get_count' => array(
			'function' => 'list_getCustomerCount',
		),
		'columns' => $columns,
	);

	require_once($sourcedir . '/Subs-List.php');

	createList($listOptions);													
	
	$context['spproc_id'] = $_REQUEST['procid'];	
	$context['spproc_orgpercent'] = $_REQUEST['procid'];
	if (empty($context['report_summ'])) $context['spproc_ordsum'] = 0;
		else $context['spproc_ordsum'] = round(array_sum($context['report_summ']), 2);	
	if (empty($context['report_org'])) $context['spproc_turnover'] = round($context['spproc_ordsum'] + 0, 2);
		else $context['spproc_turnover'] = round($context['spproc_ordsum'] + array_sum($context['report_org']), 2);
	if (!isset($modSettings['spmod_commission'])) $modSettings['spmod_commission'] = 0;
	$context['spproc_comission'] = round($context['spproc_ordsum'] * $modSettings['spmod_commission']/100, 2);
	$context['spproc_orgsum'] = round($context['spproc_turnover'] - $context['spproc_ordsum'] - $context['spproc_comission'], 2);
}

//Контроллер зоны покупок (список позиций каталога)
function SPModBuys()
{
	global $context, $txt, $sourcedir, $smcFunc, $scripturl; 
	
	isAllowedTo(array('view_spbuy'));	
	if (!isset($_REQUEST['catid'])) fatal_error($txt['spmod_nocatid']);
	if (!isset($_REQUEST['good_search'])) $_REQUEST['good_search'] = '';
	if (!isset($_REQUEST['catname'])) $_REQUEST['catname'] = $_REQUEST['catid'];
	if (!isset($_REQUEST['start'])) $_REQUEST['start'] = 0;	
	if (isset($_REQUEST['msg'])) $context['msg'] = $_REQUEST['msg'];
	if (isset($_REQUEST['procid'])) 
	{
	
		$context['page_title'] = $_REQUEST['catname'];
		$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));	
		$perpage = 10;	
		$listOptions = array(
			'id' => 'buys_list',
			'items_per_page' => $perpage,
			'title' => $txt['spmod_itemlist'] . ' "' . $_REQUEST['catname'] . '"',
			'no_items_label' => $txt['spmod_noitems'],
			'base_href' => $scripturl . '?action=spmod;sa=buys;procid='.$_REQUEST['procid'].';catid='.$_REQUEST['catid'],
			'default_sort_col' => 'name',
			'get_items' => array(
				'function' => 'list_getGoodsEntries',
			),
			'get_count' => array(
				'function' => 'list_getGoodsCount',
			),
			'columns' => array(
				'image' => array(	
					'header' => array(
						'value' => $txt['spmod_photo'],
					),
					'data' => array(
						'function' => create_function('$entry', '
							return \'<img class="goodzoom" height="300" src="\'.$entry[\'img\'].\'" alt="'.$txt['spmod_jointpurchases'].'" />\';'
						),	
						'style' => 'text-align: center; background: white;',
					),				
				),
				'name' => array(	
					'header' => array(
						'value' => $txt['spmod_description'],
					),
					'data' => array(
						'function' => create_function('$entry', '
							global $context, $scripturl, $txt;

							if (isset($entry[\'p1lc\']) && $entry[\'p1lc\'] != 0)
								$intlc = (int)$entry[\'p1lc\'];
									else 
										if (isset($entry[\'p2lc\']) && $entry[\'p2lc\'] != 0)
											$intlc = (int)$entry[\'p2lc\'];
												else $intlc = 0;
							if ($intlc == 0) $lc = \'\';
								else $lc = $txt[\'spmod_line\'] . \': \' . $intlc . $txt[\'spmod_itemcountlbl\'];					
										
							if (isset($entry[\'p1p\']) && !empty($entry[\'p1p\']))
							{
								$pa = explode(",", $entry[\'p1p\']);
								$dp1 = $entry[\'p1c\'] . \': <select name="pid1" id="p1">\';
								foreach ($pa as $p)
									$dp1 = $dp1 . \'<option value="\' . $p . \'">\' . $p . \'</option>\';
								$dp1 = $dp1 . \'</select>   \';
							}	
								else $dp1 = \'\';						
							
							return \'<strong><a href="\'.$entry[\'url\'].\'" target="_blank">\'.$entry[\'name\'].\'</a></strong><br />
							<i>\'.$entry[\'descr\'].\'</i>
							<br />
							' . $txt['spmod_articul'] . ': \' . $entry[\'art\'] . \'
							<br />
							' . $txt['spmod_price'] . ': \' . $entry[\'price\'] . \' '. $txt['spmod_currency'] . '		
							<br />
							\' . $lc . \' 
							<form action="\'. $scripturl. \'?action=spmod;sa=buy;sesc=' . $context['session_id'] . '" name="buy" id="buy" method="post">
							<br />\' . $dp1 . \'
							<br />'.$txt['spmod_count'].': 
							<select name="buy_count">
							<option value="1">1</option>
							<option value="2">2</option>
							<option value="3">3</option>
							<option value="4">4</option>
							<option value="5">5</option>
							<option value="6">6</option>
							<option value="7">7</option>
							<option value="8">8</option>
							<option value="9">9</option>
							<option value="10">10</option>
							</select>
							<br />
							<input type="hidden" value="\' . $intlc . \'" name="lc" />
							<input type="hidden" value="\' . $entry[\'p1c\'] . \'" name="p1capt" />
							<input type="hidden" value="\' . $entry[\'id\'] . \'" name="goodid" />
							<input type="hidden" value="' . $_REQUEST['procid'] . '" name="procid" />												
							<input type="hidden" value="' . $_REQUEST['catid'] . '" name="catid" />								
							<input type="hidden" value="' . $_REQUEST['catname'] . '" name="catname" />	
							<input type="hidden" value="' . $_REQUEST['start'] . '" name="start" />	
							<div class="righttext">
							<input type="submit" name="buy" value="' . $txt['spmod_addtobuscket'] . '" class="button_submit" />
							</div>
							</form>					
							\';'
						),	
						'style' => 'text-align: left;',
					),			
					'sort' => array(
						'default' => 'i.name',
						'reverse' => 'i.name DESC',
					),				
				),
			),	
		);
		
		$context['spmod_curproc'] = $_REQUEST['procid'];		
		$context['spmod_curcat'] = $_REQUEST['catid'];

		$request = $smcFunc['db_query']('', '
				SELECT name, usercat 
				FROM {db_prefix}spmod_category
				WHERE catid = {int:ca}
				LIMIT 1',
			array(
				'ca' => (int)$_REQUEST['catid'],
			)	
		);		
		$row = $smcFunc['db_fetch_row']($request);
		$context['spmod_curname'] = $row[0];
		$context['spmod_curusercat'] = $row[1];
		$smcFunc['db_free_result']($request);		
	
		ItemsQuery($_REQUEST['catid']);
			
		require_once($sourcedir . '/Subs-List.php');
		createList($listOptions);	
	}	
	else 
		fatal_error($txt['spmod_nopurch']);	
}

function ItemsQuery($cid)
{
	global $smcFunc, $context, $txt;

	if (!isset($cid))
		fatal_error($txt['spmod_nocat']);
	else	
	{		
		$context['spmod_curcat'] = $cid;
		if (isset($_REQUEST['catname']))
			$context['spmod_curname'] = $_REQUEST['catname'];
		else 
			$context['spmod_curname'] = $cid;
		$request = $smcFunc['db_query']('', '
				SELECT itemid, name, description, price, image, count 
				FROM {db_prefix}spmod_item
				WHERE catid = {int:ca}',
			array(
				'ca' => (int)$cid,
			)	
		);		
		while ($row = $smcFunc['db_fetch_row']($request))
		{
			$context['spitem_id'][] = $row[0];
			$context['spitem_name'][] = $row[1];
			$context['spitem_desr'][] = $row[2];
			$context['spitem_price'][] = $row[3];
			$context['spitem_image'][] = $row[4];
			$context['spitem_count'][] = $row[5];
		}
		$smcFunc['db_free_result']($request);
	}
}

function list_getSizesCount()
{
	global $smcFunc, $user_info;

	$request = $smcFunc['db_query']('', '
			SELECT COUNT(paramid)
			FROM {db_prefix}spmod_itemparam
			WHERE orgid = {int:or}',
		array(
			'or' => $user_info['id']
		)			
	);	
	
	list ($count) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $count;
}

function list_getSizesEntries($start, $items_per_page, $sort)
{
	global $smcFunc, $user_info;

	$request = $smcFunc['db_query']('', '
			SELECT paramid, name, caption, params, linecount 
			FROM {db_prefix}spmod_itemparam
			WHERE orgid = {int:or}',
		array(
			'or' => $user_info['id']
		)			
	);		
	$entries = array();
	while ($row = $smcFunc['db_fetch_row']($request))
	{
		$entries[] = array(
			'paramid' => $row[0],
			'name' => $row[1],
			'caption' => $row[2],
			'params' => $row[3],
			'linecount' => $row[4],
		);		
	}
	$smcFunc['db_free_result']($request);

	return $entries;
}

function CheckParamCount()
{
	if (!isset($_REQUEST['param_caption']))$_REQUEST['param_caption'] = '';
	if (!isset($_REQUEST['param_param']))$_REQUEST['param_param'] = '';			
	if (!isset($_REQUEST['param_linecount'])) $_REQUEST['param_linecount'] = 0;	
	if (!empty($_REQUEST['param_param']) and $_REQUEST['param_linecount'] != 0)
		$_REQUEST['param_linecount'] = count(explode(",", $_REQUEST['param_param']));
}

//Контроллер зоны параметров
function SPModSizes()
{
	global $smcFunc, $context, $user_info, $txt, $sourcedir, $scripturl;
	
    isAllowedTo('view_spmod');	

	if (isset($_REQUEST['do']))
	{
		//Если передаётся новая линейка параметров...
		if ($_REQUEST['do']=='add')
		{
			CheckParamCount();
			$smcFunc['db_insert']('ignore',
				'{db_prefix}spmod_itemparam',
				array(
					'name' => 'string-255', 'caption' => 'string-255', 'params' => 'string', 'orgid' => 'int', 'linecount' => 'int'
				),
				array(
					$smcFunc['htmlspecialchars']($_REQUEST['param_name'], ENT_QUOTES),
					$smcFunc['htmlspecialchars']($_REQUEST['param_caption'], ENT_QUOTES),
					$smcFunc['htmlspecialchars']($_REQUEST['param_param'], ENT_QUOTES),
					$user_info['id'],
					(int)$_REQUEST['param_linecount']
				),
				array('name')
			);	
		}
		//Удалить Параметры
		if ($_REQUEST['do']=='del')
		{
			$smcFunc['db_query']('', '
					DELETE 
					FROM {db_prefix}spmod_itemparam
					WHERE paramid = {int:id} and orgid = {int:or}',
				array(
					'id' => $_REQUEST['paramid'],
					'or' => $user_info['id'],
				)
			);						
		}
	}
	
	$context['page_title'] = $txt['spmod_lines'];
	$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));

	$context['linktree'][] = array(
		'url' => $scripturl. '?action=spmod;sa=sizes',
		'name' => $context['page_title'],
	);		
	
	$listOptions = array(
		'id' => 'lines_list',
		'items_per_page' => 10,
		'title' => $txt['spmod_addingparams'],
		'no_items_label' => $txt['spmod_noaddingparams'],
		'base_href' => $scripturl . '?action=spmod;sa=sizes',
		'default_sort_col' => 'name',
		'get_items' => array(
			'function' => 'list_getSizesEntries',
		),
		'get_count' => array(
			'function' => 'list_getSizesCount',
		),
		'columns' => array(
			'name' => array(
				'header' => array(
					'value' => $txt['spmod_paramname'],
				),
				'data' => array(
					'db' => 'name',
					'style' => 'text-align: left;',
					),	
				'sort' => array(
					'default' => 'name',
					'reverse' => 'name DESC',
				),				
			),
			'caption' => array(
				'header' => array(
					'value' => $txt['spmod_paramalias'],
				),
				'data' => array(
					'db' => 'caption',
					'style' => 'text-align: left;',
				),				
				'sort' => array(
					'default' => 'caption',
					'reverse' => 'caption DESC',
				),
			),
			'linecount' => array(
				'header' => array(
					'value' => $txt['spmod_linecount'],
				),
				'data' => array(
					'db' => 'linecount',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'linecount',
					'reverse' => 'linecount DESC',
				),				
			),			
			'params' => array(
				'header' => array(
					'value' => $txt['spmod_vallist'],
				),
				'data' => array(
					'db' => 'params',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'params',
					'reverse' => 'params DESC',
				),
			),
			'delete' => array(
				'header' => array(
					'value' => $txt['spmod_delete'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl, $txt, $context;
						return \'<a href="\' . $scripturl . \'?action=spmod;sa=sizes;do=del;paramid=\' . $entry[\'paramid\'] . \';sesc=\' . $context[\'session_id\'] . \'" onclick="return confirm(\\\'' . $txt['spmod_paramdelconf'] . '\\\');">\' . $txt[\'spmod_delete\'] . \'</a>\';'
					),	
				),				
			),		
			'edit' => array(
				'header' => array(
					'value' => $txt['spmod_edit'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl, $txt;
						return \'<a href="\' . $scripturl . \'?action=spmod;sa=editsizes;paramid=\' . $entry[\'paramid\'] . \'">\' . $txt[\'spmod_edit\'] . \'</a>\';'
					),	
				),
			),					
		),	
	);

	require_once($sourcedir . '/Subs-List.php');
	createList($listOptions);	
}

function SPModEditSizes()
{
	global $context, $smcFunc, $user_info, $scripturl, $txt;
	
    isAllowedTo('view_spmod');	
	
	if (isset($_REQUEST['paramid']))
	{
		if (isset($_REQUEST['do']))
		{
			if ($_REQUEST['do'] == 'save' and isset($_REQUEST['param_name']))
			{			
				CheckParamCount();
				$smcFunc['db_insert']('replace',
					'{db_prefix}spmod_itemparam',
					array(
						'paramid' => 'int', 'name' => 'string-255', 'caption' => 'string-255', 'params' => 'string', 'orgid' => 'int', 'linecount' => 'int'
					),
					array(
						$_REQUEST['paramid'], 
						$_REQUEST['param_name'], 
						$_REQUEST['param_caption'], 
						$_REQUEST['param_param'], 
						$user_info['id'],
						(int)$_REQUEST['param_linecount']
					),
					array('paramid')
				);
				redirectexit($scripturl.'?action=spmod;sa=sizes');		
			}
		}
		else
		{
			$context['page_title'] = $txt['spmod_lines'];
			$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));

			$context['linktree'][] = array(
				'url' => $scripturl. '?action=spmod;sa=sizes',
				'name' => $context['page_title'],
			);	
	
			$request = $smcFunc['db_query']('', '
					SELECT name, caption, params, linecount
					FROM {db_prefix}spmod_itemparam
					WHERE paramid = {int:pa}
					LIMIT 1',
				array(
					'pa' => $_REQUEST['paramid']
				)	
			);		
			$row = $smcFunc['db_fetch_row']($request);
			$smcFunc['db_free_result']($request);
			$context['param_curid'] = $_REQUEST['paramid'];
			$context['param_curname'] = $row[0];
			$context['param_curcaption'] = $row[1];
			$context['param_curparam'] = $row[2];
			$context['param_linecount'] = $row[3];
		}	
	}
	else fatal_error($txt['spmod_noparam']);
}

function SPModMyProc()
{
	global $smcFunc, $user_info, $context, $sourcedir, $scripturl, $txt;
    isAllowedTo(array('view_spbuy'));
	
	$context['page_title'] = $txt['spmod_mypurchase'];
	$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));

	$context['linktree'][] = array(
		'url' => $scripturl. '?action=spmod;sa=myproc',
		'name' => $context['page_title'],
	);		
	
	$listOptions = array(
		'id' => 'myproc_list',
		'items_per_page' => 10,
		'title' => $txt['spmod_myproc'],
		'no_items_label' => $txt['spmod_myprocempty'],
		'base_href' => $scripturl . '?action=spmod;sa=myproc',
		'default_sort_col' => 'name',
		'get_items' => array(
			'function' => 'list_getMyProcEntries',
		),
		'get_count' => array(
			'function' => 'list_getMyProcCount',
		),
		'columns' => array(
			'name' => array(
				'header' => array(
					'value' => $txt['spmod_purchname'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl;
						return \'<a href="\' . $scripturl . \'?topic=\' . $entry[\'topicid\'] . \'">\' . $entry[\'procname\'] . \'</a>\';'
					),	
				),
				'sort' => array(
					'default' => 'p.name',
					'reverse' => 'p.name DESC',
				),				
			),
			'status' => array(
				'header' => array(
					'value' => $txt['spmod_status'],
				),
				'data' => array(
					'db' => 'status',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'p.status',
					'reverse' => 'p.status DESC',
				),
			),
			'itemcount' => array(
				'header' => array(
					'value' => $txt['spmod_count'],
				),
				'data' => array(
					'db' => 'itemcount',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'itemcount',
					'reverse' => 'itemcount DESC',
				),
			),				
			'summa' => array(
				'header' => array(
					'value' => $txt['spmod_c_summa'] . ',' . $txt['spmod_currency'],
				),
				'data' => array(
					'db' => 'summa',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'summa',
					'reverse' => 'summa DESC',
				),
			),		
			'org' => array(
				'header' => array(
					'value' => $txt['spmod_orgp'] . ',' . $txt['spmod_currency'],
				),
				'data' => array(
					'db' => 'org',
					'style' => 'text-align: center;',
				),				
			),				
			'tr' => array(
				'header' => array(
					'value' => $txt['spmod_c_tr'],
				),
				'data' => array(
					'db' => 'tr',
					'style' => 'text-align: center;',
				),				
			),							
			'vsego' => array(
				'header' => array(
					'value' => $txt['spmod_koplate'] . ',' . $txt['spmod_currency'],
				),
				'data' => array(
					'db' => 'vsego',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'summa',
					'reverse' => 'summa DESC',
				),
			),									
			'payment' => array(
				'header' => array(
					'value' => $txt['spmod_payment'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl, $txt, $context, $user_info;
						if ($entry[\'payment\'] == 0) 
							return \'<form action="\'. $scripturl . \'?action=spmod;sa=pay" name="payment" id="payment" method="post" ><input type="text" name="payvalue" size="5" value="\' . $entry[\'payment\'] . \'" ><input type="hidden" name="userid" value="\' . $user_info[\'id\'] . \'" /><input type="hidden" name="procid" value="\' . $entry[\'procid\'] . \'" /><input type="hidden" name="sc" value="\' . $context[\'session_id\'] . \'" /> <input type="submit" value="\' . $txt[\'spmod_paymentcomplite\'] . \'" class="button_submit"></form>\';
						else return $txt[\'spmod_paymentcomplite\'] . \' \' . $entry[\'payment\'] . $txt[\'spmod_currency\'];
						'
					),	
				),				
			),			
		),	
	);
	require_once($sourcedir . '/Subs-List.php');
	createList($listOptions);																											
}

function SPModAdmin()
{
	global $smcFunc, $user_info, $context, $sourcedir, $scripturl, $txt, $boardurl;
    
	isAllowedTo(array('view_spadmin'));
	
	$context['page_title'] = $txt['spmod_spadmin'];
	$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));

	$context['linktree'][] = array(
		'url' => $scripturl. '?action=spmod;sa=myproc',
		'name' => $context['page_title'],
	);	
	
	if (!isset($_REQUEST['proc_start'])) $_REQUEST['proc_start'] = date('j.m.Y', strtotime('-1 month'));
	if (!isset($_REQUEST['proc_stop'])) $_REQUEST['proc_stop'] = date('j.m.Y');
	if (!isset($_REQUEST['proc_status'])) $_REQUEST['proc_status'] = '%';
	
	$context['proc_start'] = $_REQUEST['proc_start'];
	$context['proc_stop'] = $_REQUEST['proc_stop'];
	$context['proc_status'] = $_REQUEST['proc_status'];
	
	$listOptions = array(
		'id' => 'spadmin_list',
		'items_per_page' => 20,
		'title' => $txt['spmod_purchasestopdate'] . $txt['spmod_datefrom'] . $_REQUEST['proc_start'] . $txt['spmod_dateto'] . $_REQUEST['proc_stop'],
		'no_items_label' => $txt['spmod_rocempty'],
		'base_href' => $scripturl . '?action=spmod;sa=spadmin;proc_start=' . $_REQUEST['proc_start'] . ';proc_stop=' . $_REQUEST['proc_stop'] . ';proc_status=' . $_REQUEST['proc_status'],
		'default_sort_col' => 'orgname',
		'get_items' => array(
			'function' => 'list_getSPAdminEntries',
		),
		'get_count' => array(
			'function' => 'list_getSPAdminCount',
		),
		'columns' => array(
			'orgname' => array(
				'header' => array(
					'value' => $txt['spmod_t_orgname'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl;
						return \'<a href="\' . $scripturl . \'?action=pm;sa=send;u=\' . $entry[\'orgid\'] . \'">\' . $entry[\'orgname\'] . \'</a>\';'
					),	
				),				
				'sort' => array(
					'default' => 'm.real_name',
					'reverse' => 'm.real_name DESC',
				),
			),					
			'name' => array(
				'header' => array(
					'value' => $txt['spmod_purchname'],
				),
				'data' => array(
					'function' => create_function('$entry', '
						global $scripturl;
						return \'<a href="\' . $scripturl . \'?topic=\' . $entry[\'topicid\'] . \'">\' . $entry[\'procname\'] . \'</a>\';'
					),	
				),
				'sort' => array(
					'default' => 'p.name',
					'reverse' => 'p.name DESC',
				),				
			),	
			'status' => array(
				'header' => array(
					'value' => $txt['spmod_status'],
				),
				'data' => array(
					'db' => 'status',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'p.status',
					'reverse' => 'p.status DESC',
				),
			),
			'startdate' => array(
				'header' => array(
					'value' => $txt['spmod_dateopen'],
				),
				'data' => array(
					'db' => 'startdate',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'p.startdate',
					'reverse' => 'p.startdate DESC',
				),
			),
			'stopdate' => array(
				'header' => array(
					'value' => $txt['spmod_purchasestopdate'],
				),
				'data' => array(
					'db' => 'stopdate',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'p.stopdate',
					'reverse' => 'p.stopdate DESC',
				),
			),			
			'itemsum' => array(
				'header' => array(
					'value' => $txt['spmod_c_summa'],
				),
				'data' => array(
					'db' => 'itemsum',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'summ',
					'reverse' => 'summ DESC',
				),
			),		
			'orgperc' => array(
				'header' => array(
					'value' => $txt['spmod_orgp'],
				),
				'data' => array(
					'db' => 'orgperc',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'p.orgpercent',
					'reverse' => 'p.orgpercent DESC',
				),
			),	
			'orgsum' => array(
				'header' => array(
					'value' => $txt['spmod_summaorgpercent'],
				),
				'data' => array(
					'db' => 'orgsum',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'org',
					'reverse' => 'org DESC',
				),
			),
			'commission' => array(
				'header' => array(
					'value' => $txt['spmod_comission'],
				),
				'data' => array(
					'db' => 'commission',
					'style' => 'text-align: center;',
				),				
				'sort' => array(
					'default' => 'summ',
					'reverse' => 'summ DESC',
				),
			),				
			'edit' => array(
				'header' => array(
					'value' => $txt['spmod_action'],
					'style' => 'width:80px',
				),
				'data' => array(
					'function' => create_function('$entry', '
						return \'<a href="' . $scripturl . '?action=spmod;sa=reportproc;procid=\' . $entry[\'procid\'] . \';procname=\' . $entry[\'procname\'] . \' "><img src="' . $boardurl . '/SPMod/images/sp/money.png" alt="'.$txt['spmod_report'].'" title="'.$txt['spmod_report'].'"></a>
						<a href="' . $scripturl . '?action=spmod;sa=closeproc2;procid=\' . $entry[\'procid\'] . \';sesc=' . $context['session_id'] . '"><img src="' . $boardurl . '/SPMod/images/sp/closed.png" alt="'.$txt['spmod_purchstat_doclose'].'" title="'.$txt['spmod_purchstat_doclose'].'"></a>\';'
					),	
				),
			),
			'check' => array(
				'header' => array(
					'value' => '<input type="checkbox" onclick="invertAll(this, this.form);" class="input_check" />',
				),
				'data' => array(
					'function' => create_function('$entry', '
						return \'<input type="checkbox" name="procid[]" value="\' . $entry[\'procid\'] . \'" class="input_check" />\';
					'),
					'class' => 'windowbg',
					'style' => 'text-align: center',
				),
			),			
		),	
	);
	require_once($sourcedir . '/Subs-List.php');
	createList($listOptions);
}

function SPmodOrgInfo()
{
	global $smcFunc, $user_info, $context, $scripturl, $txt;

    isAllowedTo(array('view_spbuy', 'view_spmod'));
	
	if (isset($_REQUEST['do']))
	{
		if ($_REQUEST['do'] == 'save')
		{			
			if (!isset($_REQUEST['org_name']))$_REQUEST['org_name'] = '';
			if (!isset($_REQUEST['org_phone']))$_REQUEST['org_phone'] = '';
			if (!isset($_REQUEST['org_distrib']))$_REQUEST['org_distrib'] = '';	
			if (!isset($_REQUEST['org_address']))$_REQUEST['org_address'] = '';	

			$smcFunc['db_insert']('replace',
				'{db_prefix}spmod_orginfo',
				array(
					'orgname' => 'string-255', 
					'orgphone' => 'string-255', 
					'orgid' => 'int',
					'distribution' => 'string-255', 
					'address' => 'string-255', 
				),
				array(
					$_REQUEST['org_name'], $_REQUEST['org_phone'], $user_info['id'], $_REQUEST['org_distrib'], $_REQUEST['org_address']
				),
				array('orgid')
			);	
		}
	}
	
	$context['page_title'] = $txt['spmod_orginfo'];
	$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));
	
	$context['linktree'][] = array(
  		'url' => $scripturl. '?action=spmod;sa=orginfo',
 		'name' => $context['page_title'],
	);		
	
	$request = $smcFunc['db_query']('', '
			SELECT orgname, orgphone, distribution, address, requisites
			FROM {db_prefix}spmod_orginfo
			WHERE orgid = {int:or}',
		array(
			'or' => $user_info['id']
		)			
	);		
	$row = $smcFunc['db_fetch_row']($request);
	$context['orginfo_name'] = $row[0];
	$context['orginfo_phone'] = $row[1];
	$context['orginfo_distrib'] = $row[2];
	$context['orginfo_address'] = $row[3];
	$context['orginfo_requisites'] = $row[4];
	$smcFunc['db_free_result']($request);	
}

function SPModParser()
{	
	global $context, $parsers, $smcFunc, $txt, $scripturl;
	include_once('SPMod/parsers.php');
	isAllowedTo('view_spmod');

	$context['page_title'] = $txt['spmod_parser'];
	$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));

	$context['linktree'][] = array(
		'url' => $scripturl. '?action=spmod;sa=parser',
		'name' => $context['page_title'],
	);		
	
	GetCatsByUserID();
	$context['parsers'] = $parsers;
}

function Parse()
{
	global $scripturl, $txt, $parsers;
	
	include_once('SPMod/parsers.php');
	
	if (!isset($_POST['parser_url'])) fatal_error($txt['spmod_nopageurl']);	
	isAllowedTo('view_spmod');
	checkSession();
	
	if (isset($_POST['newcatname']) && !empty($_POST['newcatname']))
		$catid = CreateNewCat($_POST['newcatname']);
	elseif
		(isset($_POST['catid']) && $_POST['catid'] != '-1') $catid = (int)$_POST['catid'];	
	else fatal_error($txt['spmod_nocat']);
	
	if (stripos($_POST['parser_url'], '<body>') !== false)
		$links = array($_POST['parser_url']);
	else 
		$links = explode(PHP_EOL, $_POST['parser_url']);
		
	foreach($links as $link)
		foreach($parsers as $key => $value)
			if (stripos($link, $key) !== false && function_exists($value))
			{
				$parseresults = $value(trim($link));
				foreach($parseresults as $parseresult)
					ItemToDB($catid, $parseresult['name'], $parseresult['description'], $parseresult['image'], $parseresult['price'], $parseresult['link'], $parseresult['articul'], $parseresult['linecount'], $parseresult['params'], $parseresult['linecaption']);
			}	
	redirectexit($scripturl . '?action=spmod;sa=goods;catid=' . $catid);
}

function pcgbasename($param, $suffix=null) 
{ 
	if ( $suffix ) 
	{ 
		$tmpstr = ltrim(substr($param, strrpos($param, DIRECTORY_SEPARATOR) ), DIRECTORY_SEPARATOR); 
        if ((strpos($param, $suffix)+strlen($suffix) )  ==  strlen($param) ) 
		{ 
			return str_ireplace( $suffix, '', $tmpstr); 
        } 
		else
		{ 
            return ltrim(substr($param, strrpos($param, DIRECTORY_SEPARATOR) ), DIRECTORY_SEPARATOR); 
        } 
    } 
	else 
	{ 
        return ltrim(substr($param, strrpos($param, DIRECTORY_SEPARATOR) ), DIRECTORY_SEPARATOR); 
    } 
}

function file_force_download1($file) {
  if (file_exists($file)) {
    header('Content-Description: File Transfer');
    header('Content-Type: application/octet-stream');
    header('Content-Disposition: attachment; filename="' . pcgbasename($file) . '"');
    header('Content-Transfer-Encoding: binary');
    header('Expires: 0');
    header('Cache-Control: must-revalidate');
    header('Pragma: public');
    header('Content-Length: ' . filesize($file));
	readfile($file);
    exit;
  }
}

function file_force_download2($file) 
{
	if (file_exists($file)) 
	{	
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header('Content-Disposition: attachment; filename=' . basename($file));
		header('Content-Transfer-Encoding: binary');
		header('Expires: 0');
		header('Cache-Control: must-revalidate');
		header('Pragma: public');
		header('Content-Length: ' . filesize($file));
		if ($fd = fopen($file, 'rb')) 
		{
			while (!feof($fd)) 
			{
				print fread($fd, 1024);
				fclose($fd);
			}
			exit;
		}
	}
}

function SaveToXML()
{
	global $smcFunc, $txt;
	isAllowedTo('view_spmod');
	checkSession('get');	
	if (isset($_REQUEST['catid']))
	{
		$request = $smcFunc['db_query']('', '
				SELECT name 
				FROM {db_prefix}spmod_category
				WHERE catid = {int:ca}
				LIMIT 1',
			array(
				'ca' => $_REQUEST['catid']
			)			
		);		
		$row = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);
		$catname = $row[0];

		//Создает XML-строку и XML-документ при помощи DOM 
		$dom = new DomDocument('1.0'); 
		$cat = $dom->appendChild($dom->createElement('catalog')); 
		$title = $cat->appendChild($dom->createElement('catname')); 

		// добавление элемента текстового узла <title> в <title> 
		$title->appendChild( 
						$dom->createTextNode($catname));
	
		$request = $smcFunc['db_query']('', '
				SELECT 
					name,
					description,
					price,
					image, 
					articul, 
					link, 
					param1, 
					param2, 
					linecount,
					params,
					linecaption
				FROM {db_prefix}spmod_item	
				WHERE catid = {int:ca}
				',
			array(
				'ca' => $_REQUEST['catid']
			)	
		);		
		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			$item = $cat->appendChild($dom->createElement('item')); 
			
			$itemname = $item->appendChild($dom->createElement('itemname')); 
			$itemname->appendChild( 
							$dom->createTextNode($row['name']));				

			$itemdescr = $item->appendChild($dom->createElement('itemdescr')); 
			$itemdescr->appendChild( 
							$dom->createTextNode($row['description']));				

			$itemprice = $item->appendChild($dom->createElement('price')); 
			$itemprice->appendChild( 
							$dom->createTextNode($row['price']));		
			
			$itemimage = $item->appendChild($dom->createElement('image')); 
			$itemimage->appendChild( 
							$dom->createTextNode($row['image']));		
			
			$itemarticul = $item->appendChild($dom->createElement('articul')); 
			$itemarticul->appendChild( 
							$dom->createTextNode($row['articul']));				

			$itemlink = $item->appendChild($dom->createElement('link')); 
			$itemlink->appendChild( 
							$dom->createTextNode($row['link']));		
			
			$itemlink = $item->appendChild($dom->createElement('linecount')); 
			$itemlink->appendChild( 
							$dom->createTextNode($row['linecount']));			
			
			$itemlink = $item->appendChild($dom->createElement('params')); 
			$itemlink->appendChild( 
							$dom->createTextNode($row['params']));			
			
			$itemlink = $item->appendChild($dom->createElement('linecaption')); 
			$itemlink->appendChild( 
							$dom->createTextNode($row['linecaption']));						
		}
		$smcFunc['db_free_result']($request);						
		//генерация xml 
		$dom->formatOutput = true; // установка атрибута formatOutput
		$catname = iconv("utf-8", "cp1251", $catname);		
		$dom->save('SPMod/'.$catname.'.xml'); // сохранение файла 			
		file_force_download1('SPMod/'.$catname.'.xml');
	}
	else
		fatal_error($txt['spmod_nocat']);
}

function CreateNewCat($catname, $usercat = 0)
{
	global $smcFunc, $user_info;

	$smcFunc['db_insert']('ignore',
		'{db_prefix}spmod_category',
		array(
			'name' => 'string-255', 'count' => 'int', 'orgid' => 'int', 'usercat' => 'int'
		),
		array(
			$smcFunc['htmlspecialchars']($catname, ENT_QUOTES),
			0,
			$user_info['id'],
			$usercat,
		),
		array('name')
	);		
	return $smcFunc['db_insert_id']('{db_prefix}spmod_category', 'catid'); 		
}

function LoadFromXML()
{
	global $smcFunc, $user_info, $txt;
	isAllowedTo('view_spmod');
	checkSession();
	if($_FILES["filename"]["size"] > 1024*3*1024)
		fatal_error($txt['spmod_filetoolarge']);

	if(is_uploaded_file($_FILES["filename"]["tmp_name"]))
	{
		$sxe = simplexml_load_string(file_get_contents($_FILES["filename"]["tmp_name"]));
		if ($sxe === false) 
			fatal_error($txt['spmod_parsingerror']);
		else
		{
			$request = $smcFunc['db_query']('', '
				SELECT catid
				FROM {db_prefix}spmod_category
				WHERE name = "'.$sxe->catname[0].'" AND orgid = '.$user_info['id'].'
				LIMIT 1'
			);

			$row = $smcFunc['db_fetch_row']($request);
			$catid = $row[0];
			$smcFunc['db_free_result']($request);
 			if (isset($catid)) 
				$catid = $row[0];
			else
				$catid = CreateNewCat($sxe->catname[0]);
			foreach($sxe->item as $sxec)
				ItemToDB($catid, $sxec->itemname, $sxec->itemdescr, $sxec->image, floatval($sxec->price), $sxec->link, $sxec->articul, $sxec->linecount, $sxec->params, $sxec->linecaption);	
		}
	}	
	else
		fatal_error($txt['spmod_erroruploading']);
}

function LoadFromCSV()
{
	global $smcFunc, $user_info, $txt, $scripturl, $language;

	include('SPMod/DataSource.php');
	isAllowedTo('view_spmod');
	checkSession();
	if($_FILES["filename"]["size"] > 1024*3*1024)
 		fatal_error($txt['spmod_filetoolarge']);
	
	if(is_uploaded_file($_FILES["filename"]["tmp_name"]))
	{
		$csv = new File_CSV_DataSource;

		$settings = 'settings'; 
		$newSettings = array(
                 'delimiter'=>';', 
                 'length'=>999999, 
                 'escape'=>'"'
              );

		$csv->$settings = $newSettings;
				
		$csv->load($_FILES["filename"]["tmp_name"]);
		
		if (!$csv->isSymmetric()) {
			fatal_error('file has headers and rows with different lengths cannot connect');
		}		
		
		if ($csv === false) 
		{
			fatal_error($txt['spmod_parsingerror']);
		} else
		{		
			if (isset($_REQUEST['cat_name']))
			{	
				$request = $smcFunc['db_query']('', '
					SELECT catid
					FROM {db_prefix}spmod_category
					WHERE name = "' . $_REQUEST['cat_name'] . '" AND orgid = '.$user_info['id'].'
					LIMIT 1'
				);
				$row = $smcFunc['db_fetch_row']($request);
				$catid = $row[0];
				$smcFunc['db_free_result']($request);
				if (isset($catid)) 
				{
					$catid = $row[0];
				}
				else
					$catid = CreateNewCat($_REQUEST['cat_name']);								
				$headers = $csv->getHeaders();
				$upload_data = $csv->connect();				
				$UTF = (stripos($language, 'UTF') !== false);
				if ($UTF)
				{
					$hName = iconv('UTF-8','CP1251',$txt['hName']); 		$hName2 = iconv('UTF-8','CP1251',$txt['hName2']);		$hName3 = iconv('UTF-8','CP1251',$txt['hName3']);
					$hArticul = iconv('UTF-8','CP1251',$txt['hArticul']);	$hArticul2 = iconv('UTF-8','CP1251',$txt['hArticul2']);	$hArticul3 = iconv('UTF-8','CP1251',$txt['hArticul3']);
					$hDescr = iconv('UTF-8','CP1251',$txt['hDescr']);		$hDescr2 = iconv('UTF-8','CP1251',$txt['hDescr2']);		$hDescr3 = iconv('UTF-8','CP1251',$txt['hDescr3']);
					$hPrice = iconv('UTF-8','CP1251',$txt['hPrice']);		$hPrice2 = iconv('UTF-8','CP1251',$txt['hPrice2']);		$hPrice3 = iconv('UTF-8','CP1251',$txt['$hPrice3']);
					$hPic = iconv('UTF-8','CP1251',$txt['hPic']);			$hPic2 = iconv('UTF-8','CP1251',$txt['hPic2']);			$hPic3 = iconv('UTF-8','CP1251',$txt['$hPic3']); 
					$hLink = iconv('UTF-8','CP1251',$txt['hLink']);			$hLink2 = iconv('UTF-8','CP1251',$txt['hLink2']);		$hLink2 = iconv('UTF-8','CP1251',$txt['$hLink2']);
					$hRow = iconv('UTF-8','CP1251',$txt['hRow']);			$hRow2 = iconv('UTF-8','CP1251',$txt['hRow2']);			$hRow3 = iconv('UTF-8','CP1251',$txt['$hRow3']);
					$hParam = iconv('UTF-8','CP1251',$txt['hParam']);		$hParam2 = iconv('UTF-8','CP1251',$txt['hParam2']);		$hParam3 = iconv('UTF-8','CP1251',$txt['$hParam3']);
					$hValues = iconv('UTF-8','CP1251',$txt['hValues']);		$hValues2 = iconv('UTF-8','CP1251',$txt['hValues2']);	$hValues3 = iconv('UTF-8','CP1251',$txt['$hValues3']);
				} else
				{
					$hName = $txt['hName']; 		$hName2 = $txt['hName2'];		$hName3 = $txt['hName3'];
					$hArticul = $txt['hArticul'];	$hArticul2 = $txt['hArticul2'];	$hArticul3 = $txt['hArticul3'];
					$hDescr = $txt['hDescr'];		$hDescr2 = $txt['hDescr2'];		$hDescr3 = $txt['hDescr3'];
					$hPrice = $txt['hPrice'];		$hPrice2 = $txt['hPrice2'];		$hPrice3 = $txt['$hPrice3'];
					$hPic = $txt['hPic'];			$hPic2 = $txt['hPic2'];			$hPic3 = $txt['$hPic3']; 
					$hLink = $txt['hLink'];			$hLink2 = $txt['hLink2'];		$hLink2 = $txt['$hLink2'];
					$hRow = $txt['hRow'];			$hRow2 = $txt['hRow2'];			$hRow3 = $txt['$hRow3'];
					$hParam = $txt['hParam'];		$hParam2 = $txt['hParam2'];		$hParam3 = $txt['$hParam3'];
					$hValues = $txt['hValues'];		$hValues2 = $txt['hValues2'];	$hValues3 = $txt['$hValues3'];					
				}
				foreach($headers as $header) {
					if ((stripos($header, $hName) 		!== false)||(stripos($header, $hName2) 		!== false)||(stripos($header, $hName3) 		!== false)) $hName = $header;
					if ((stripos($header, $hArticul)	!== false)||(stripos($header, $hArticul2)	!== false)||(stripos($header, $hArticul3)	!== false)) $hArticul = $header;
					if ((stripos($header, $hDescr)		!== false)||(stripos($header, $hDescr2)		!== false)||(stripos($header, $hDescr3)		!== false)) $hDescr = $header;
					if ((stripos($header, $hPrice)		!== false)||(stripos($header, $hPrice2)		!== false)||(stripos($header, $hPrice3)		!== false)) $hPrice = $header;
					if ((stripos($header, $hPic)		!== false)||(stripos($header, $hPic2)		!== false)||(stripos($header, $hPic3)		!== false)) $hPic = $header;
					if ((stripos($header, $hLink)		!== false)||(stripos($header, $hLink2)		!== false)||(stripos($header, $hLink3)		!== false)) $hLink = $header;
					if ((stripos($header, $hRow)		!== false)||(stripos($header, $hRow2)		!== false)||(stripos($header, $hRow3)		!== false)) $hLink = $hRow;
					if ((stripos($header, $hValues)		!== false)||(stripos($hValues,$hValues2)	!== false)||(stripos($hValues,$hValues3)	!== false)) $hValues = $header;
				}
				if ($UTF)
				foreach($upload_data as $csvrow)
				{
					$itemname = iconv('CP1251', 'UTF-8', $csvrow[$hName]);
					$itemart = iconv('CP1251', 'UTF-8', $csvrow[$hArticul]);
					$itemdes = iconv('CP1251', 'UTF-8', $csvrow[$hDescr]);
					$itempri = iconv('CP1251', 'UTF-8', $csvrow[$hPrice]);
					$itemima = iconv('CP1251', 'UTF-8', $csvrow[$hPic]);
					$itemlin = iconv('CP1251', 'UTF-8', $csvrow[$hLink]);
					$itemrow = iconv('CP1251', 'UTF-8', $csvrow[$hRow]);
					$itemsiz = iconv('CP1251', 'UTF-8', $csvrow[$hParam]);
					$itemval = iconv('CP1251', 'UTF-8', $csvrow[$hValues]);
					ItemToDB($catid, $itemname, $itemdes, $itemima, $itempri, $itemlin, $itemart, $itemrow, $itemval, $itemsiz);	
				} 
				else
				foreach($upload_data as $csvrow)
				{
					$itemname = $csvrow[$hName];
					$itemart = $csvrow[$hArticul];
					$itemdes = $csvrow[$hDescr];
					$itempri = $csvrow[$hPrice];
					$itemima = $csvrow[$hPic];
					$itemlin = $csvrow[$hLink];
					$itemrow = $csvrow[$hRow];
					$itemsiz = $csvrow[$hParam];
					$itemval = $csvrow[$hValues];
					ItemToDB($catid, $itemname, $itemdes, $itemima, $itempri, $itemlin, $itemart, $itemrow, $itemval, $itemsiz);	
				}					

			} else fatal_error($txt['spmod_erroruploading']);
		}	
	}
	redirectexit($scripturl.'?action=spmod;sa=spcat');	
}

function SPHelp()
{
	global $context, $txt, $scripturl, $smcFunc;
	
	$context['page_title'] = $txt['spmod_sphelp'];
	$context['page_title_html_safe'] = $smcFunc['htmlspecialchars'](un_htmlspecialchars($context['page_title']));

	$context['linktree'][] = array(
		'url' => $scripturl. '?action=spmod;sa=help',
		'name' => $context['page_title'],
	);		
}

?>